﻿var FWEditor = (function() {
	var version = "0.13";
	var lastupdate = "2017/09/30";
	var idcount = 0;
	var Sqsize = 16;
	var Maxwidth = 100;
	var Maxheight = 100;
	var Defaultwidth = 20;
	var Defaultheight = 20;

	var Country = [ 
		{ fname: "no", npc: true },
		{ fname: "rs" },
		{ fname: "bm" },
		{ fname: "ge" },
		{ fname: "yc" },
		{ fname: "bh" },
	];

	var Terrain_imglist = {
		plain:			{ land: true, receiveshadow: true, imgdata: { num: 0, ix: 1, iy :0, sx: 3, sy: 1, height: 16 } },
		plain_pd:		{ land: true, pipe: true, connect: true, imgdata: { num: 0, ix: 4, iy :0, height: 16 } },
		wood:				{ land: true, shadow: true, imgdata: { num: 0, ix: 14, iy: 4, num2: 1, ix2: 2, iy2: 0, height: 32 } },
		mountain:		{ land: true, shadow: true, imgdata: { num: 0, ix: 7, iy:11, num2: 1, ix2: 4, iy2: 0, height: 32 } },
		road:				{ land: true, connect: true, receiveshadow: true, imgdata: { num: 0, ix: 7, iy :3, height: 16 } },
		bridge:			{ connect: true, imgdata: { num: 0, ix: 21, iy: 0, height: 16 } },
		pipe:				{ land: true, pipe: true, connect: true, imgdata: { num: 0, ix: 3, iy: 11, height: 16 } },
		pipe_c:			{ land: true, pipe: true, connect: true, candestroy: true, hp: 99, imgdata: { num: 0, ix: 5, iy: 12, height: 16 } },
		river:			{ land: true, connect: true, imgdata: { num: 0, ix: 25, iy: 0, height: 16 } },
		sea:				{ sea: true, connect: true, imgdata: { num: 0, ix: 12, iy: 1, height: 16 } },
		reef:				{ sea: true, imgdata: { num: 0, ix: 11, iy: 12, height: 16 } },
		shoal:			{ sea: true, connect: true, imgdata: { num: 0, ix: 10, iy: 8, height: 16 } },
		missle:			{ land: true, shadow: true, imgdata: { num: 3, ix: 0, iy: 0, height: 32 } },
		misslenone:	{ land: true, shadow: true, imgdata: { num: 3, ix: 6, iy: 1, height: 16 } },
		wideriver:	{ land: true, connect: true, imgdata: { num: 0, ix: 1, iy :1, height: 16 } },
		road10:			{ land: true, receiveshadow: true, imgdata: { num: 0, ix:  7, iy : 3, sx: 11, sy: 5, height: 16 } },
		road5:			{ land: true, receiveshadow: true, imgdata: { num: 0, ix:  4, iy : 2, sx:  8, sy: 4, height: 16 } },
		road3:			{ land: true, receiveshadow: true, imgdata: { num: 0, ix:  6, iy : 3, sx: 10, sy: 5, height: 16 } },
		road6:			{ land: true, receiveshadow: true, imgdata: { num: 0, ix:  5, iy : 2, sx:  9, sy: 4, height: 16 } },
		road12:			{ land: true, receiveshadow: true, imgdata: { num: 0, ix:  6, iy : 2, sx: 10, sy: 4, height: 16 } },
		road9:			{ land: true, receiveshadow: true, imgdata: { num: 0, ix:  8, iy : 3, sx: 12, sy: 5, height: 16 } },
		road7:			{ land: true, receiveshadow: true, imgdata: { num: 0, ix: 26, iy : 7, sx: 28, sy: 7, height: 16 } },
		road14:			{ land: true, receiveshadow: true, imgdata: { num: 0, ix: 25, iy : 7, sx: 27, sy: 7, height: 16 } },
		road13:			{ land: true, receiveshadow: true, imgdata: { num: 0, ix: 23, iy : 6, sx: 25, sy: 6, height: 16 } },
		road11:			{ land: true, receiveshadow: true, imgdata: { num: 0, ix: 22, iy : 6, sx: 24, sy: 6, height: 16 } },
		road15:			{ land: true, receiveshadow: true, imgdata: { num: 0, ix: 27, iy : 8, sx: 28, sy: 8, height: 16 } },
		bridgeh:		{ imgdata: { num: 0, ix: 21, iy : 0, height: 16 } },
		bridgev:		{ imgdata: { num: 0, ix: 22, iy : 0, height: 16 } },
		pipe10:			{ land: true, pipe: true, imgdata: { num: 0, ix:  3, iy : 11, height: 16 } },
		pipe5:			{ land: true, pipe: true, imgdata: { num: 0, ix:  4, iy : 11, height: 16 } },
		pipe3:			{ land: true, pipe: true, imgdata: { num: 0, ix:  3, iy : 12, height: 16 } },
		pipe6:			{ land: true, pipe: true, imgdata: { num: 0, ix:  1, iy : 11, height: 16 } },
		pipe12:			{ land: true, pipe: true, imgdata: { num: 0, ix:  2, iy : 11, height: 16 } },
		pipe9:			{ land: true, pipe: true, imgdata: { num: 0, ix:  4, iy : 12, height: 16 } },
		pipe4:			{ land: true, pipe: true, imgdata: { num: 0, ix: 29, iy :  8, height: 16 } },
		pipe8:			{ land: true, pipe: true, imgdata: { num: 0, ix:  0, iy : 10, height: 16 }, newline: true  },
		pipe1:			{ land: true, pipe: true, imgdata: { num: 0, ix:  0, iy :  9, height: 16 } },
		pipe2:			{ land: true, pipe: true, imgdata: { num: 0, ix: 29, iy :  9, height: 16 }, space: 1 },
		pipe_cv:		{ land: true, pipe: true, imgdata: { num: 0, ix:  6, iy : 12, height: 16 }, candestroy: true, hp: 99 },
		pipe_ch:		{ land: true, pipe: true, imgdata: { num: 0, ix:  5, iy : 12, height: 16 }, candestroy: true, hp: 99 },
		plain_pdh:	{ land: true, pipe: true, imgdata: { num: 0, ix:  1, iy : 10, height: 16 } },
		plain_pdv:	{ land: true, pipe: true, imgdata: { num: 0, ix:  2, iy : 10, height: 16 }, newline: true },
		river10:		{ land: true, imgdata: { num: 0, ix: 25, iy :  0, height: 16 } },
		river5:			{ land: true, imgdata: { num: 0, ix: 24, iy :  0, height: 16 } },
		river19:		{ land: true, imgdata: { num: 0, ix:  2, iy :  4, height: 16 } },
		river38:		{ land: true, imgdata: { num: 0, ix:  0, iy :  3, height: 16 } },
		river76:		{ land: true, imgdata: { num: 0, ix:  1, iy :  3, height: 16 } },
		river137:		{ land: true, imgdata: { num: 0, ix:  3, iy :  4, height: 16 } },
		river55:		{ land: true, imgdata: { num: 0, ix: 19, iy :  7, height: 16 } },
		river110:		{ land: true, imgdata: { num: 0, ix: 22, iy :  9, height: 16 } },
		river205:		{ land: true, imgdata: { num: 0, ix: 20, iy :  7, height: 16 } },
		river155:		{ land: true, imgdata: { num: 0, ix: 24, iy : 10, height: 16 } },
		river255:		{ land: true, imgdata: { num: 0, ix: 27, iy :  0, height: 16 } },
		river3:			{ land: true, imgdata: { num: 0, ix:  6, iy :  6, height: 16 } },
		river6:			{ land: true, imgdata: { num: 0, ix:  4, iy :  5, height: 16 } },
		river12:		{ land: true, imgdata: { num: 0, ix:  5, iy :  5, height: 16 } },
		river9:			{ land: true, imgdata: { num: 0, ix:  7, iy :  6, height: 16 } },
		river7:			{ land: true, imgdata: { num: 0, ix:  4, iy :  3, height: 16 } },
		river23:		{ land: true, imgdata: { num: 0, ix:  8, iy :  5, height: 16 } },
		river39:		{ land: true, imgdata: { num: 0, ix:  6, iy :  4, height: 16 } },
		river14:		{ land: true, imgdata: { num: 0, ix:  0, iy :  2, height: 16 } },
		river46:		{ land: true, imgdata: { num: 0, ix: 20, iy :  6, height: 16 } },
		river78:		{ land: true, imgdata: { num: 0, ix: 21, iy :  6, height: 16 } },
		river13:		{ land: true, imgdata: { num: 0, ix:  5, iy :  3, height: 16 } },
		river77:		{ land: true, imgdata: { num: 0, ix:  7, iy :  4, height: 16 } },
		river141:		{ land: true, imgdata: { num: 0, ix:  9, iy :  5, height: 16 } },
		river11:		{ land: true, imgdata: { num: 0, ix:  1, iy :  2, height: 16 } },
		river139:		{ land: true, imgdata: { num: 0, ix: 24, iy :  7, height: 16 } },
		river27:		{ land: true, imgdata: { num: 0, ix: 23, iy :  7, height: 16 } },
		river15:		{ land: true, imgdata: { num: 0, ix:  1, iy :  1, height: 16 } },
		sea_r1:			{ imgdata: { num: 0, ix: 25, iy :  9, height: 16 } },
		sea_r2:			{ imgdata: { num: 0, ix: 26, iy :  9, height: 16 } },
		sea_r4:			{ imgdata: { num: 0, ix: 23, iy :  8, height: 16 } },
		sea_r8:			{ imgdata: { num: 0, ix: 24, iy :  8, height: 16 } },
		sea0:				{ imgdata: { num: 0, ix: 12, iy :  1, height: 16 } },
		sea1:				{ imgdata: { num: 0, ix: 14, iy :  2, height: 16 } },
		sea2:				{ imgdata: { num: 0, ix: 10, iy :  1, height: 16 } },
		sea4:				{ imgdata: { num: 0, ix: 10, iy :  0, height: 16 } },
		sea8:				{ imgdata: { num: 0, ix: 14, iy :  1, height: 16 } },
		sea5:				{ imgdata: { num: 0, ix: 18, iy :  3, height: 16 } },
		sea10:			{ imgdata: { num: 0, ix: 12, iy :  0, height: 16 } },
		sea3:				{ imgdata: { num: 0, ix: 13, iy :  2, height: 16 } },
		sea6:				{ imgdata: { num: 0, ix: 11, iy :  1, height: 16 } },
		sea12:			{ imgdata: { num: 0, ix: 13, iy :  1, height: 16 } },
		sea9:				{ imgdata: { num: 0, ix: 15, iy :  2, height: 16 } },
		sea7:				{ imgdata: { num: 0, ix: 19, iy :  4, height: 16 } },
		sea14:			{ imgdata: { num: 0, ix: 17, iy :  4, height: 16 } },
		sea13:			{ imgdata: { num: 0, ix: 16, iy :  3, height: 16 } },
		sea11:			{ imgdata: { num: 0, ix: 14, iy :  3, height: 16 } },
		sea15:			{ imgdata: { num: 0, ix:  8, iy :  0, height: 16 } },
		sea16:			{ imgdata: { num: 0, ix: 12, iy :  2, height: 16 } },
		sea32:			{ imgdata: { num: 0, ix:  9, iy :  0, height: 16 } },
		sea64:			{ imgdata: { num: 0, ix: 11, iy :  0, height: 16 } },
		sea128:			{ imgdata: { num: 0, ix: 16, iy :  2, height: 16 } },
		sea48:			{ imgdata: { num: 0, ix: 18, iy :  4, height: 16 } },
		sea80:			{ imgdata: { num: 0, ix: 13, iy :  0, height: 16 } },
		sea144:			{ imgdata: { num: 0, ix: 16, iy :  4, height: 16 } },
		sea96:			{ imgdata: { num: 0, ix: 15, iy :  3, height: 16 } },
		sea160:			{ imgdata: { num: 0, ix: 15, iy :  1, height: 16 } },
		sea192:			{ imgdata: { num: 0, ix: 17, iy :  3, height: 16 } },
		sea112:			{ imgdata: { num: 0, ix:  7, iy : 10, height: 16 } },
		sea176:			{ imgdata: { num: 0, ix:  9, iy : 10, height: 16 } },
		sea208:			{ imgdata: { num: 0, ix: 10, iy : 10, height: 16 } },
		sea224:			{ imgdata: { num: 0, ix:  8, iy : 10, height: 16 } },
		sea240:			{ imgdata: { num: 0, ix: 11, iy : 10, height: 16 } },
		sea33:			{ imgdata: { num: 0, ix:  3, iy :  8, height: 16 } },
		sea65:			{ imgdata: { num: 0, ix:  4, iy :  8, height: 16 } },
		sea97:			{ imgdata: { num: 0, ix:  5, iy :  8, height: 16 } },
		sea66:			{ imgdata: { num: 0, ix: 19, iy :  5, height: 16 } },
		sea130:			{ imgdata: { num: 0, ix:  1, iy :  7, height: 16 } },
		sea194:			{ imgdata: { num: 0, ix: 21, iy :  5, height: 16 } },
		sea132:			{ imgdata: { num: 0, ix:  6, iy :  9, height: 16 } },
		sea20:			{ imgdata: { num: 0, ix:  5, iy :  9, height: 16 } },
		sea148:			{ imgdata: { num: 0, ix:  7, iy :  9, height: 16 } },
		sea24:			{ imgdata: { num: 0, ix:  0, iy :  7, height: 16 } },
		sea40:			{ imgdata: { num: 0, ix: 18, iy :  5, height: 16 } },
		sea56:			{ imgdata: { num: 0, ix: 20, iy :  5, height: 16 } },
		sea67:			{ imgdata: { num: 0, ix:  7, iy :  8, height: 16 } },
		sea134:			{ imgdata: { num: 0, ix:  9, iy :  9, height: 16 } },
		sea28:			{ imgdata: { num: 0, ix:  8, iy :  9, height: 16 } },
		sea41:			{ imgdata: { num: 0, ix:  6, iy :  8, height: 16 } },
		sea_r1:			{ imgdata: { num: 0, ix: 25, iy :  9, height: 16 } },
		sea_r2:			{ imgdata: { num: 0, ix: 26, iy :  9, height: 16 } },
		sea_r4:			{ imgdata: { num: 0, ix: 23, iy :  8, height: 16 } },
		sea_r8:			{ imgdata: { num: 0, ix: 24, iy :  8, height: 16 } },
		shoal1:			{ imgdata: { num: 0, ix: 10, iy :  8, height: 16 } },
		shoal17:		{ imgdata: { num: 0, ix:  5, iy :  7, height: 16 } },
		shoal129:		{ imgdata: { num: 0, ix:  6, iy :  7, height: 16 } },
		shoal145:		{ imgdata: { num: 0, ix: 20, iy :  2, height: 16 } },
		shoal2:			{ imgdata: { num: 0, ix: 26, iy :  4, height: 16 } },
		shoal34:		{ imgdata: { num: 0, ix: 25, iy :  5, height: 16 } },
		shoal18:		{ imgdata: { num: 0, ix:  7, iy :  7, height: 16 } },
		shoal50:		{ imgdata: { num: 0, ix: 16, iy :  1, height: 16 } },
		shoal4:			{ imgdata: { num: 0, ix: 23, iy :  4, height: 16 } },
		shoal68:		{ imgdata: { num: 0, ix: 20, iy :  3, height: 16 } },
		shoal36:		{ imgdata: { num: 0, ix: 19, iy :  3, height: 16 } },
		shoal100:		{ imgdata: { num: 0, ix: 16, iy :  0, height: 16 } },
		shoal8:			{ imgdata: { num: 0, ix: 27, iy :  4, height: 16 } },
		shoal136:		{ imgdata: { num: 0, ix:  8, iy :  7, height: 16 } },
		shoal72:		{ imgdata: { num: 0, ix: 26, iy :  5, height: 16 } },
		shoal200:		{ imgdata: { num: 0, ix: 20, iy :  1, height: 16 } },
		shoal3:			{ imgdata: { num: 0, ix: 16, iy :  9, height: 16 } },
		shoal35:		{ imgdata: { num: 0, ix: 28, iy :  5, height: 16 } },
		shoal131:		{ imgdata: { num: 0, ix: 16, iy :  9, height: 16 } },
		shoal163:		{ imgdata: { num: 0, ix: 18, iy :  2, height: 16 } },
		shoal6:			{ imgdata: { num: 0, ix: 12, iy :  6, height: 16 } },
		shoal70:		{ imgdata: { num: 0, ix: 14, iy :  8, height: 16 } },
		shoal22:		{ imgdata: { num: 0, ix: 10, iy :  7, height: 16 } },
		shoal86:		{ imgdata: { num: 0, ix: 17, iy :  1, height: 16 } },
		shoal12:		{ imgdata: { num: 0, ix: 13, iy :  6, height: 16 } },
		shoal140:		{ imgdata: { num: 0, ix: 11, iy :  7, height: 16 } },
		shoal44:		{ imgdata: { num: 0, ix: 13, iy :  8, height: 16 } },
		shoal172:		{ imgdata: { num: 0, ix: 19, iy :  1, height: 16 } },
		shoal9:			{ imgdata: { num: 0, ix: 16, iy :  7, height: 16 } },
		shoal25:		{ imgdata: { num: 0, ix: 15, iy :  9, height: 16 } },
		shoal73:		{ imgdata: { num: 0, ix: 29, iy :  5, height: 16 } },
		shoal89:		{ imgdata: { num: 0, ix: 21, iy :  2, height: 16 } },
		shoal7:			{ imgdata: { num: 0, ix: 24, iy :  2, height: 16 } },
		shoal14:		{ imgdata: { num: 0, ix: 25, iy :  2, height: 16 } },
		shoal13:		{ imgdata: { num: 0, ix: 23, iy :  2, height: 16 } },
		shoal11:		{ imgdata: { num: 0, ix: 27, iy :  3, height: 16 } },
		mcannon_u:	{ land: true, candestroy: true, hp: 99, shadow: true, imgdata: { num: 3, ix: 3, iy :  0, height: 32 } },
		mcannon_r:	{ land: true, candestroy: true, hp: 99, shadow: true, imgdata: { num: 3, ix: 5, iy :  0, height: 32 } },
		mcannon_d:	{ land: true, candestroy: true, hp: 99, shadow: true, imgdata: { num: 3, ix: 2, iy :  0, height: 32 } },
		mcannon_l:	{ land: true, candestroy: true, hp: 99, shadow: true, imgdata: { num: 3, ix: 4, iy :  0, height: 32 } },
		mcannon_all:	{ land: true, candestroy: true, hp: 99, shadow: true, imgdata: { num: 3, ix: 1, iy :  0, height: 32 } },
		bstone:			{ land: true, candestroy: true, hp: 99, shadow: true, newline: true, imgdata: { num: 3, ix: 7, iy :  0, height: 32 } },
	};

	var Buildinglist = {
		hq:				{	land: true, hq: true, shadow: true, imgdata: { num: 2, ix: 0, iy : 0, height: 32 } },
		city:			{	land: true, shadow: true, imgdata: { num: 2, ix: 6, iy : 0, height: 32 } },
		base:			{	land: true, shadow: true , imgdata: { num: 2, ix: 6, iy : 2, height: 32 }},
		airport:	{	land: true, shadow: true, imgdata: { num: 2, ix: 6, iy : 4, height: 32 } },
		seaport:	{	land: true, shadow: true, imgdata: { num: 2, ix: 6, iy : 6, height: 32 } },
		comtower: {	land: true, shadow: true, imgdata: { num: 2, ix: 6, iy : 8, height: 32 } },
		rlab:			{	land: true, hq: true, shadow: true, imgdata: { num: 2, ix: 0, iy : 10, height: 32 } },
	}

	var LargeBuildinglist = {
		bcannon_u:	{ land: true, large: true, size: 3, destroyx: 1, destroyy: 2, imgdata: { num: 4, ix: 3, iy : 0, height: 48 } },
		bcannon_d:	{ land: true, large: true, size: 3, destroyx: 1, destroyy: 2, imgdata: { num: 4, ix: 0, iy : 0, height: 48 } },
		bcrystal:		{ land: true, large: true, size: 3, destroyx: 1, destroyy: 2, imgdata: { num: 4, ix: 6, iy : 0, height: 48 } },
		bruin:			{ land: true, large: true, size: 3, imgdata: { num: 4, ix: 9, iy : 0, height: 48 } },
		misslelauncher:	{ land: true, large: true, size: 4, imgdata: { num: 4, ix: 0, iy : 3, height: 64 } },
		largebuilding:	{ land: true, large: true, size: 4, imgdata: { num: 4, ix: 4, iy : 3, height: 64 } },
		volcano:		{ land: true, large: true, size: 4, imgdata: { num: 4, ix: 8, iy : 3, height: 64 } },
		blackarc:		{ land: true, large: true, size: 4, imgdata: { num: 4, ix: 4, iy : 7, height: 64 } },
	}
	var Toolpx = 20;
	var Toolpy = 20;


	var Tool_terrain_space = 30;
	var Tool_terrain_xnum = 8;
	var Tool_building_margin = 20;
	var Tool_extra_margin = 20;


	var Tool_country_height = 40;

	var Tool_button_width = 30;
	var Tool_button_height = 30;
	var ButtonUI_data = [
		{ type:	"img",	name: "new" },
		{ type:	"img",	name: "open" },
		{ type:	"img",	name: "save" },
	];

	var Tool_mode_width = 50;
	var Tool_mode_height = 25;
	var ModeUI_data = [
		{ type: "text", name: "Terrain",	align: "center", border: true },
		{ type: "text", name: "Extra",		align: "center", border: true },
		{ type: "text", name: "Unit",			align: "center", border: true },
		{ type: "text", name: "Map",			align: "center", border: true },
	];

	var Terrain_UI_width = 30;
	var Terrain_UI_height = 30;
	var TerrainUI_data = [
		{	type: "imgsp",	name:	"plain" },
		{	type: "imgsp",	name:	"plain_pd" },
		{	type: "imgsp",	name:	"wood" },
		{	type: "imgsp",	name:	"mountain" },
		{	type: "imgsp",	name:	"road" },
		{	type: "imgsp",	name:	"bridge" },
		{	type: "imgsp",	name:	"pipe" },
		{	type: "imgsp",	name:	"pipe_c" },
		{ type: "newline" },
		{	type: "imgsp",	name:	"river" },
		{	type: "imgsp",	name:	"sea" },
		{	type: "imgsp",	name:	"reef" },
		{	type: "imgsp",	name:	"shoal" },
		{	type: "imgsp",	name:	"missle" },
		{	type: "imgsp",	name:	"misslenone" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"wideriver" },
		{ type: "newline", y: 50 },
	];

	var ExtraUI_data = [
		{	type: "imgsp",	name:	"road10" },
		{	type: "imgsp",	name:	"road5" },
		{	type: "imgsp",	name:	"road3" },
		{	type: "imgsp",	name:	"road6" },
		{	type: "imgsp",	name:	"road12" },
		{	type: "imgsp",	name:	"road9" },
		{	type: "imgsp",	name:	"road7" },
		{	type: "imgsp",	name:	"road14" },
		{ type: "newline" },
		{	type: "imgsp",	name:	"road13" },
		{	type: "imgsp",	name:	"road11" },
		{	type: "imgsp",	name:	"road15" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"bridgeh" },
		{	type: "imgsp",	name:	"bridgev" },
		{ type: "newline" },
		{	type: "imgsp",	name:	"river10" },
		{	type: "imgsp",	name:	"river5" },
		{	type: "imgsp",	name:	"river19" },
		{	type: "imgsp",	name:	"river38" },
		{	type: "imgsp",	name:	"river76" },
		{	type: "imgsp",	name:	"river137" },
		{	type: "imgsp",	name:	"river55" },
		{	type: "imgsp",	name:	"river110" },
		{ type: "newline" },
		{	type: "imgsp",	name:	"river205" },
		{	type: "imgsp",	name:	"river155" },
		{	type: "imgsp",	name:	"river255" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"sea_r1" },
		{	type: "imgsp",	name:	"sea_r2" },
		{	type: "imgsp",	name:	"sea_r4" },
		{	type: "imgsp",	name:	"sea_r8" },
		{ type: "newline" },
		{	type: "imgsp",	name:	"pipe10" },
		{	type: "imgsp",	name:	"pipe5" },
		{	type: "imgsp",	name:	"pipe3" },
		{	type: "imgsp",	name:	"pipe6" },
		{	type: "imgsp",	name:	"pipe12" },
		{	type: "imgsp",	name:	"pipe9" },
		{	type: "imgsp",	name:	"pipe4" },
		{	type: "imgsp",	name:	"pipe8" },
		{ type: "newline" },
		{	type: "imgsp",	name:	"pipe1" },
		{	type: "imgsp",	name:	"pipe2" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"pipe_cv" },
		{	type: "imgsp",	name:	"pipe_ch" },
		{	type: "imgsp",	name:	"plain_pdh" },
		{	type: "imgsp",	name:	"plain_pdv" },
		{ type: "newline" },
		{	type: "imgsp",	name:	"mcannon_u" },
		{	type: "imgsp",	name:	"mcannon_r" },
		{	type: "imgsp",	name:	"mcannon_d" },
		{	type: "imgsp",	name:	"mcannon_l" },
		{	type: "imgsp",	name:	"mcannon_all" },
		{	type: "imgsp",	name:	"bstone" },
		{ type: "newline" },
	];

	var UnitCountryUI_data = [
		{ type: "img",	name: "rs" },
		{ type: "img",	name: "bm" },
		{ type: "img",	name: "ge" },
		{ type: "img",	name: "yc" },
		{ type: "img",	name: "bh" },
	];

	var Tool_mapsize_height = 20;
	var Tool_mapsize_padding = 5;
	var MapsizeUI_data = [
		{ type: "text",	name: "size",														width: 50, height: Tool_mapsize_height, align: "left",		padding: Tool_mapsize_padding, border: false, select: { fillStyle: "transparent" } },
		{ type: "var",	name: "param.savedata.mapdata.width",		width: 50, height: Tool_mapsize_height, align: "right",		padding: Tool_mapsize_padding, border: true },
		{ type: "text",	name: "×",															width: 30, height: Tool_mapsize_height, align: "center",	padding: Tool_mapsize_padding, border: false, select: { fillStyle: "transparent" } },
		{ type: "var",	name: "param.savedata.mapdata.height",	width: 50, height: Tool_mapsize_height, align: "right",		padding: Tool_mapsize_padding, border: true },
	];


	for (var i = 0 ; i < Country.length ; i++) {
		var c = Country[i];
		for (var bname in Buildinglist) {
			var b = Buildinglist[bname];
			var cname = c.fname;
			var t = Terrain_imglist[bname + "_" + cname] = copyobject(b);
			if (bname == "hq") {
				t.imgdata.ix = i;
				t.imgdata.iy = (i - 1) * 2;
				if (c.npc) {
					TerrainUI_data.push({ type: "space", x: Terrain_UI_width });
				}
				else {
					TerrainUI_data.push({ type: "imgsp", name: bname + "_" + cname });
				}
			}
			else {
				t.imgdata.ix += i;
				TerrainUI_data.push({ type: "imgsp", name: bname + "_" + cname });
			}
		}
		TerrainUI_data.push({ type: "newline" });
	}
	for (var bname in LargeBuildinglist) {
		var b = LargeBuildinglist[bname];
		Terrain_imglist[bname] = copyobject(b);
		for (var x = 0 ; x < b.size ; x++) {
			for (var y = 0 ; y < b.size ; y++) {
				var t = Terrain_imglist[bname + x + "" + y] = copyobject(b);
				t.imgdata.ix += x;
				t.imgdata.iy += y;
				t.imgdata.x = x;
				t.imgdata.y = y;
				t.imgdata.height = 16;
			}
		}
		ExtraUI_data.push({ type: "imgsp", name: bname });
	}

	var Toolwidth = Toolpx * 2 + Tool_terrain_space * (Tool_terrain_xnum - 1) + Sqsize;
	var Toolheight = Tool_button_height + Tool_mode_height;

	var Tool_select_rectsize = Sqsize + 8;
	var Tool_select_rectcolor = "gray";

	function getmyid() {
		idcount++;
		return idcount;
	}

	function copyobject(obj) {
		if (typeof obj != "object") {
			return obj;
		}
		var type = Object.prototype.toString.call(obj);
		if (type == "[object Object]") {
			var retval = {};
			for (var p in obj) {
				retval[p] = copyobject(obj[p]);
			}
			return retval;
		}
		else if (type == "[object Array]") {
			var retval = [];
			for (var i = 0 ; i < obj.length ; i++) {
				retval[i] = copyobject(obj[i]);
			}
			return retval;
		}
		else {
			return obj;
		}
	}

	function Rect(x, y, w, h) {
		this.x = +x || 0;
		this.y = +y || 0;
		this.w = +w || 10;
		this.h = +h || 10;
	}
	Rect.prototype.isinside = function(x, y) {
		x = +x || 0;
		y = +y || 0;
		if (this.x <= x && x < this.x + this.w && this.y <= y && y < this.y + this.h) {
			return true;
		}
		else {
			return false;
		}
	}

	function UI(param, data) {
		param = param || {};
		this.lx =							param.x || 0;
		this.ly =							param.y || 0;
		this.type =						param.type || "button";
		this.imgpath =				param.imgpath || "";
		this.imgext =					param.imgext || ".png";
		this.imgpx =					param.imgpx || 0;
		this.imgpy =					param.imgpy || 0;
		this.defaultwidth = 	param.defaultwidth || 16;
		this.defaultheight = 	param.defaultheight || 16;
		this.px	= 						param.px || 0;
		this.py =							param.py || 0;
		this.space =					param.space || 0;
		this.lineheight = 		param.lineheight || 16;
		this.selectnum =			0;
		this.select	= {
			font:					(param.select && param.select.font) || 				"sans serif",
			fontsize:			(param.select && param.select.fontsize) ||		12,
			textStyle:		(param.select && param.select.textStyle) ||		"black",
			strokeStyle:	(param.select && param.select.strokeStyle) ||	"black",
			lineWidth:		(param.select && param.select.lineWidth) ||	1,
			fillStyle:		(param.select && param.select.fillStyle) ||		"transparent",
		};
		this.unselect	= {
			font:					(param.unselect && param.unselect.font) || 				"sans serif",
			fontsize:			(param.unselect && param.unselect.fontsize) ||		12,
			textStyle:		(param.unselect && param.unselect.textStyle) ||		"black",
			strokeStyle:	(param.unselect && param.unselect.strokeStyle) ||	"black",
			lineWidth:		(param.unselect && param.unselect.lineWidth) ||	1,
			fillStyle:		(param.unselect && param.unselect.fillStyle) ||		"lightgray",
		};
		this.dataorig = data || [];
		this.data = [];
		this.settooldata();
	}

	UI.prototype.settooldata = function() {
		var x = this.px;
		var y = this.py;
		var data = this.data = copyobject(this.dataorig);
		for (var i = 0 ; i < data.length ; i++) {
			var d = data[i];
			if (d.type === "space") {
				x += (d.x || 0);
				data.splice(i, 1);
				i--;
				continue;
			}
			if (d.type === "newline") {
				x = this.px;
				y += (d.y || this.lineheight);
				data.splice(i, 1);
				i--;
				continue;
			}
			var width = d.width || this.defaultwidth;
			var height = d.height || this.defaultheight;
			d.toolrect = new Rect(this.lx + x, this.ly + y, width, height);
			if (d.type === "img") {
				d.image = new Image();
				if (d.src) {
					d.image.src = this.imgpath + d.src;
				}
				else {
					d.image.src = this.imgpath + d.name + this.imgext;
				}
			}
			x += width + this.space;
		}
	}

	UI.prototype.draw = function(ctx, tx, ty, param) {
		for (var i = 0 ; i < this.data.length ; i++) {
			var d = this.data[i];
			var style, dstyle;

			if (this.type === "selector" && i != this.selectnum) {
				style = this.unselect;
				dstyle = d.unselect || style;
			}
			else {
				style = this.select;
				dstyle = d.select || style;
			}

			ctx.beginPath();
			ctx.fillStyle = dstyle.fillStyle || style.fillStyle;
			ctx.rect(tx + d.toolrect.x, ty  + d.toolrect.y, d.toolrect.w, d.toolrect.h);
			ctx.fill();
			if (d.border) {
				ctx.beginPath();
				ctx.strokeStyle = dstyle.strokeStyle || style.strokeStyle;
				ctx.lineWidth = dstyle.lineWidth || style.lineWidth;
				ctx.rect(tx + d.toolrect.x, ty  + d.toolrect.y + 1, d.toolrect.w, d.toolrect.h);
				ctx.stroke();
			}
			if (d.type === "text" || d.type === "var") {
				var x = d.toolrect.x;
				var txt = d.name;
				if (d.type === "var") {
					txt = eval(d.name);
				}
				ctx.fillStyle = dstyle.textStyle || style.textStyle;
				ctx.font = (dstyle.fontsize || style.fontsize) + "px " + (dstyle.font || style.font);
				var twidth = ctx.measureText(txt).width;
				var padding = d.padding || this.padding;
				if (d.align == "left") {
					x += padding;
				}
				else if (d.align == "right") {
					x += (d.toolrect.w - padding - twidth);
				}
				else if (d.align == "center") {
					x += (d.toolrect.w - twidth) / 2;
				}
				ctx.fillText(txt, tx + x, ty + d.toolrect.y + ((dstyle.fontsize || style.fontsize) + d.toolrect.h) / 2);
			}
			else if (d.type === "img") {
				var ix = tx + d.toolrect.x + (d.px || this.imgpx);
				var iy = ty + d.toolrect.y + (d.py || this.imgpy);
				var iw = d.imgwidth || d.image.width;
				var ih = d.imgheight || d.image.height;
				ctx.drawImage(d.image, ix, iy, iw, ih);
			}
			else if (d.type === "imgsp") {
				var ix = tx + d.toolrect.x + (d.px || this.imgpx);
				var iy = ty + d.toolrect.y + (d.py || this.imgpy);
				var iw = d.imgwidth || 16;
				var ih = d.imgheight || 16;
				param.drawterrain(d.name, ix, iy, 0, 0, null, t.image[param.savedata.mapdata.maptype]);
//				ctx.beginPath();
//				ctx.fillStyle = "red";
//				ctx.rect(ix, iy, iw, ih);
//				ctx.fill();
			}
		}
	}

	UI.prototype.getselectdata = function() {
		return this.data[this.selectnum];
	}

	UI.prototype.getclickdata = function(x, y) {
		for (var i = 0 ; i < this.data.length ; i++) {
			var d = this.data[i];
			if (d.toolrect.isinside(x, y)) {
				return d;
			}
		}
		return null;
	}

	UI.prototype.selectdata = function(data) {
		for (var i = 0; i < this.data.length ; i++) {
			var d = this.data[i];
			if (d.name == data.name) {
				this.selectnum = i;
				break;
			}
		}
	}

	UI.prototype.selectnext = function() {
		if (this.data.length == 0) {
			return;
		}
		this.selectnum = (this.selectnum + 1) % this.data.length;
	}

	UI.prototype.selectprev = function() {
		if (this.data.length == 0) {
			return;
		}
		this.selectnum = (this.selectnum + this.data.length - 1) % this.data.length;
	}

	var Terrain = [
		{	fname:	"plain",      def: 1, land: true, receiveshadow: true, imgdata: { num: 0, ix: 1, iy : 0, sx: 3, sy: 1, height: 16 } },
		{	fname:	"plain_pd",   def: 1, land: true, pipe: true, connect: true, imgdata: { num: 0, ix: 4, iy : 0, height: 16 } },
		{	fname:	"wood",       def: 2, land: true, shadow: true, imgdata: { num: 1, ix: 0, iy : 0, height: 32 } },
		{	fname:	"mountain",   def: 3, land: true, shadow: true, imgdata: { num: 1, ix: 2, iy : 0, height: 32 } },
		{	fname:	"road",       def: 0, land: true, connect: true, receiveshadow: true, imgdata: { num: 0, ix: 7, iy : 3, height: 16 } },
		{	fname:	"bridge",     def: 0, connect: true, imgdata: { num: 0, ix: 21, iy : 0, height: 16 } },
		{	fname:	"pipe",       def: 0, land: true, pipe: true, connect: true, imgdata: { num: 0, ix: 3, iy : 11, height: 16 } },
		{	fname:	"pipe_c",     def: 0, land: true, pipe: true, connect: true, candestroy: true, hp: 99, imgdata: { num: 1, ix: 2, iy : 3, height: 16 } },
		{	fname:	"river",      def: 0, land: true, connect: true, imgdata: { num: 0, ix: 25, iy : 0, height: 16 } },
		{	fname:	"sea",        def: 0, sea: true, connect: true, imgdata: { num: 0, ix: 12, iy : 1, height: 16 } },
		{	fname:	"reef",       def: 1, sea: true, imgdata: { num: 1, ix: 4, iy : 3, height: 16 } },
		{	fname:	"shoal",      def: 0, sea: true, connect: true, imgdata: { num: 0, ix: 10, iy : 8, height: 16 } },
		{	fname:	"missle",     def: 0, land: true, shadow: true, imgdata: { num: 1, ix: 4, iy : 0, height: 32 } },
		{	fname:	"misslenone", def: 0, land: true, shadow: true, imgdata: { num: 1, ix: 9, iy : 3, height: 16 }, space: 1 },
		{	fname:	"wideriver",  def: 0, land: true, connect: true, imgdata: { num: 0, ix: 1, iy : 1, height: 16 } },
	];

	var Building = [
		{	fname:	"hq", def: 4, land: true, building: true, income: true, hq: true, shadow: true },
		{	fname:	"city", def: 3, land: true, building: true, income: true, shadow: true },
		{	fname:	"base", def: 3, land: true, building: true, income: true, shadow: true },
		{	fname:	"airport", def: 3, land: true, building: true, income: true, shadow: true },
		{	fname:	"seaport", def: 3, land: true, building: true, income: true, shadow: true },
		{	fname:	"comtower", def: 3, land: true, building: true, shadow: true },
		{	fname:	"rlab", def: 4, land: true, building: true, income: true, hq: true, shadow: true },
	]

	var Extra = [
		{	fname:	"road10", def: 0, land: true, receiveshadow: true, imgdata: { num: 0, ix:  7, iy : 3, sx: 11, sy: 5, height: 16 } },
		{	fname:	"road5",  def: 0, land: true, receiveshadow: true, imgdata: { num: 0, ix:  4, iy : 2, sx:  8, sy: 4, height: 16 } },
		{	fname:	"road3",  def: 0, land: true, receiveshadow: true, imgdata: { num: 0, ix:  6, iy : 3, sx: 10, sy: 5, height: 16 } },
		{	fname:	"road6",  def: 0, land: true, receiveshadow: true, imgdata: { num: 0, ix:  5, iy : 2, sx:  9, sy: 4, height: 16 } },
		{	fname:	"road12", def: 0, land: true, receiveshadow: true, imgdata: { num: 0, ix:  6, iy : 2, sx: 10, sy: 4, height: 16 } },
		{	fname:	"road9",  def: 0, land: true, receiveshadow: true, imgdata: { num: 0, ix:  8, iy : 3, sx: 12, sy: 5, height: 16 } },
		{	fname:	"road7",  def: 0, land: true, receiveshadow: true, imgdata: { num: 0, ix: 26, iy : 7, sx: 28, sy: 7, height: 16 } },
		{	fname:	"road14", def: 0, land: true, receiveshadow: true, imgdata: { num: 0, ix: 25, iy : 7, sx: 27, sy: 7, height: 16 }, newline: true },
		{	fname:	"road13", def: 0, land: true, receiveshadow: true, imgdata: { num: 0, ix: 23, iy : 6, sx: 25, sy: 6, height: 16 } },
		{	fname:	"road11", def: 0, land: true, receiveshadow: true, imgdata: { num: 0, ix: 22, iy : 6, sx: 24, sy: 6, height: 16 } },
		{	fname:	"road15", def: 0, land: true, receiveshadow: true, imgdata: { num: 0, ix: 27, iy : 8, sx: 28, sy: 8, height: 16 }, space: 1 },
		{	fname:	"bridgeh", def: 0, imgdata: { num: 0, ix: 21, iy : 0, height: 16 } },
		{	fname:	"bridgev", def: 0, imgdata: { num: 0, ix: 22, iy : 0, height: 16 }, newline: true },
		{	fname:	"river10",  def: 0, land: true, imgdata: { num: 0, ix: 25, iy :  0, height: 16 } },
		{	fname:	"river5",   def: 0, land: true, imgdata: { num: 0, ix: 24, iy :  0, height: 16 } },
		{	fname:	"river19",  def: 0, land: true, imgdata: { num: 0, ix:  2, iy :  4, height: 16 } },
		{	fname:	"river38",  def: 0, land: true, imgdata: { num: 0, ix:  0, iy :  3, height: 16 } },
		{	fname:	"river76",  def: 0, land: true, imgdata: { num: 0, ix:  1, iy :  3, height: 16 } },
		{	fname:	"river137", def: 0, land: true, imgdata: { num: 0, ix:  3, iy :  4, height: 16 } },
		{	fname:	"river55",  def: 0, land: true, imgdata: { num: 0, ix: 19, iy :  7, height: 16 } },
		{	fname:	"river110", def: 0, land: true, imgdata: { num: 0, ix: 22, iy :  9, height: 16 }, newline: true },
		{	fname:	"river205", def: 0, land: true, imgdata: { num: 0, ix: 20, iy :  7, height: 16 } },
		{	fname:	"river155", def: 0, land: true, imgdata: { num: 0, ix: 24, iy : 10, height: 16 } },
		{	fname:	"river255", def: 0, land: true, imgdata: { num: 0, ix: 27, iy :  0, height: 16 }, space: 1 },
		{	fname:	"sea_r1", def: 0, imgdata: { num: 0, ix: 25, iy :  9, height: 16 } },
		{	fname:	"sea_r2", def: 0, imgdata: { num: 0, ix: 26, iy :  9, height: 16 } },
		{	fname:	"sea_r4", def: 0, imgdata: { num: 0, ix: 23, iy :  8, height: 16 } },
		{	fname:	"sea_r8", def: 0, imgdata: { num: 0, ix: 24, iy :  8, height: 16 }, newline: true },
		{	fname:	"pipe10", land: true, pipe: true, imgdata: { num: 0, ix:  3, iy : 11, height: 16 } },
		{	fname:	"pipe5",  land: true, pipe: true, imgdata: { num: 0, ix:  4, iy : 11, height: 16 } },
		{	fname:	"pipe3",  land: true, pipe: true, imgdata: { num: 1, ix:  0, iy :  3, height: 16 } },
		{	fname:	"pipe6",  land: true, pipe: true, imgdata: { num: 0, ix:  1, iy : 11, height: 16 } },
		{	fname:	"pipe12", land: true, pipe: true, imgdata: { num: 0, ix:  2, iy : 11, height: 16 } },
		{	fname:	"pipe9",  land: true, pipe: true, imgdata: { num: 1, ix:  1, iy :  3, height: 16 } },
		{	fname:	"pipe4",  land: true, pipe: true, imgdata: { num: 0, ix: 29, iy :  8, height: 16 } },
		{	fname:	"pipe8",  land: true, pipe: true, imgdata: { num: 0, ix:  0, iy : 10, height: 16 }, newline: true  },
		{	fname:	"pipe1",  land: true, pipe: true, imgdata: { num: 0, ix:  0, iy :  9, height: 16 } },
		{	fname:	"pipe2",  land: true, pipe: true, imgdata: { num: 0, ix: 29, iy :  9, height: 16 }, space: 1 },
		{	fname:	"pipe_cv", land: true, pipe: true, imgdata: { num: 1, ix: 3, iy :  3, height: 16 }, candestroy: true, hp: 99 },
		{	fname:	"pipe_ch", land: true, pipe: true, imgdata: { num: 1, ix: 2, iy :  3, height: 16 }, candestroy: true, hp: 99 },
		{	fname:	"plain_pdh", def: 1, land: true, pipe: true, imgdata: { num: 0, ix: 1, iy : 10, height: 16 } },
		{	fname:	"plain_pdv", def: 1, land: true, pipe: true, imgdata: { num: 0, ix: 2, iy : 10, height: 16 }, newline: true },
		{	fname:	"mcannon_u", land: true, candestroy: true, hp: 99, shadow: true, imgdata: { num: 1, ix: 7, iy :  0, height: 32 } },
		{	fname:	"mcannon_r", land: true, candestroy: true, hp: 99, shadow: true, imgdata: { num: 1, ix: 9, iy :  0, height: 32 } },
		{	fname:	"mcannon_d", land: true, candestroy: true, hp: 99, shadow: true, imgdata: { num: 1, ix: 6, iy :  0, height: 32 } },
		{	fname:	"mcannon_l", land: true, candestroy: true, hp: 99, shadow: true, imgdata: { num: 1, ix: 8, iy :  0, height: 32 } },
		{	fname:	"mcannon_all", land: true, candestroy: true, hp: 99, shadow: true, imgdata: { num: 1, ix: 5, iy :  0, height: 32 } },
		{	fname:	"bstone", land: true, candestroy: true, hp: 99, shadow: true, newline: true, imgdata: { num: 1, ix: 10, iy :  0, height: 32 } },
		{	fname:	"bcannon_u", land: true, large: true, size: 3, destroyx: 1, destroyy: 2 },
		{	fname:	"bcannon_d", land: true, large: true, size: 3, destroyx: 1, destroyy: 2 },
		{	fname:	"bcannon2", land: true, large: true, size: 3, destroyx: 1, destroyy: 2 },
		{	fname:	"bcrystal", land: true, large: true, size: 3, destroyx: 1, destroyy: 2, newline: true },
		{	fname:	"volcano", land: true, large: true, size: 4 },
		{	fname:	"blackarc", land: true, large: true, size: 4 },
		{	fname:	"blackarc2", sea: true, large: true, size: 4 },
		{	fname:	"largebuilding", land: true, large: true, size: 4 },
		{	fname:	"misslelauncher", land: true, large: true, size: 4 },

		{	fname:	"sea0",   hidden: true, imgdata: { num: 0, ix: 12, iy :  1, height: 16 } },
		{	fname:	"sea1",   hidden: true, imgdata: { num: 0, ix: 14, iy :  2, height: 16 } },
		{	fname:	"sea2",   hidden: true, imgdata: { num: 0, ix: 10, iy :  1, height: 16 } },
		{	fname:	"sea4",   hidden: true, imgdata: { num: 0, ix: 10, iy :  0, height: 16 } },
		{	fname:	"sea8",   hidden: true, imgdata: { num: 0, ix: 14, iy :  1, height: 16 } },
		{	fname:	"sea5",   hidden: true, imgdata: { num: 0, ix: 18, iy :  3, height: 16 } },
		{	fname:	"sea10",  hidden: true, imgdata: { num: 0, ix: 12, iy :  0, height: 16 } },
		{	fname:	"sea3",   hidden: true, imgdata: { num: 0, ix: 13, iy :  2, height: 16 } },
		{	fname:	"sea6",   hidden: true, imgdata: { num: 0, ix: 11, iy :  1, height: 16 } },
		{	fname:	"sea12",  hidden: true, imgdata: { num: 0, ix: 13, iy :  1, height: 16 } },
		{	fname:	"sea9",   hidden: true, imgdata: { num: 0, ix: 15, iy :  2, height: 16 } },
		{	fname:	"sea7",   hidden: true, imgdata: { num: 0, ix: 19, iy :  4, height: 16 } },
		{	fname:	"sea14",  hidden: true, imgdata: { num: 0, ix: 17, iy :  4, height: 16 } },
		{	fname:	"sea13",  hidden: true, imgdata: { num: 0, ix: 16, iy :  3, height: 16 } },
		{	fname:	"sea11",  hidden: true, imgdata: { num: 1, ix:  7, iy :  3, height: 16 } },
		{	fname:	"sea15",  hidden: true, imgdata: { num: 0, ix:  8, iy :  0, height: 16 } },
		{	fname:	"sea16",  hidden: true, imgdata: { num: 0, ix: 12, iy :  2, height: 16 } },
		{	fname:	"sea32",  hidden: true, imgdata: { num: 0, ix:  9, iy :  0, height: 16 } },
		{	fname:	"sea64",  hidden: true, imgdata: { num: 0, ix: 11, iy :  0, height: 16 } },
		{	fname:	"sea128", hidden: true, imgdata: { num: 0, ix: 16, iy :  2, height: 16 } },
		{	fname:	"sea48",  hidden: true, imgdata: { num: 0, ix: 18, iy :  4, height: 16 } },
		{	fname:	"sea80",  hidden: true, imgdata: { num: 0, ix: 13, iy :  0, height: 16 } },
		{	fname:	"sea144", hidden: true, imgdata: { num: 0, ix: 16, iy :  4, height: 16 } },
		{	fname:	"sea96",  hidden: true, imgdata: { num: 1, ix:  8, iy :  3, height: 16 } },
		{	fname:	"sea160", hidden: true, imgdata: { num: 0, ix: 15, iy :  1, height: 16 } },
		{	fname:	"sea192", hidden: true, imgdata: { num: 0, ix: 17, iy :  3, height: 16 } },
		{	fname:	"sea112", hidden: true, imgdata: { num: 1, ix:  5, iy :  3, height: 16 } },
		{	fname:	"sea176", hidden: true, imgdata: { num: 0, ix:  9, iy : 10, height: 16 } },
		{	fname:	"sea208", hidden: true, imgdata: { num: 0, ix: 10, iy : 10, height: 16 } },
		{	fname:	"sea224", hidden: true, imgdata: { num: 1, ix:  6, iy :  3, height: 16 } },
		{	fname:	"sea240", hidden: true, imgdata: { num: 0, ix: 11, iy : 10, height: 16 } },
		{	fname:	"sea33",  hidden: true, imgdata: { num: 0, ix:  3, iy :  8, height: 16 } },
		{	fname:	"sea65",  hidden: true, imgdata: { num: 0, ix:  4, iy :  8, height: 16 } },
		{	fname:	"sea97",  hidden: true, imgdata: { num: 0, ix:  5, iy :  8, height: 16 } },
		{	fname:	"sea66",  hidden: true, imgdata: { num: 0, ix: 19, iy :  5, height: 16 } },
		{	fname:	"sea130", hidden: true, imgdata: { num: 0, ix:  1, iy :  7, height: 16 } },
		{	fname:	"sea194", hidden: true, imgdata: { num: 0, ix: 21, iy :  5, height: 16 } },
		{	fname:	"sea132", hidden: true, imgdata: { num: 0, ix:  6, iy :  9, height: 16 } },
		{	fname:	"sea20",  hidden: true, imgdata: { num: 0, ix:  5, iy :  9, height: 16 } },
		{	fname:	"sea148", hidden: true, imgdata: { num: 0, ix:  7, iy :  9, height: 16 } },
		{	fname:	"sea24",  hidden: true, imgdata: { num: 0, ix:  0, iy :  7, height: 16 } },
		{	fname:	"sea40",  hidden: true, imgdata: { num: 0, ix: 18, iy :  5, height: 16 } },
		{	fname:	"sea56",  hidden: true, imgdata: { num: 0, ix: 20, iy :  5, height: 16 } },
		{	fname:	"sea67",  hidden: true, imgdata: { num: 0, ix:  7, iy :  8, height: 16 } },
		{	fname:	"sea134", hidden: true, imgdata: { num: 0, ix:  9, iy :  9, height: 16 } },
		{	fname:	"sea28",  hidden: true, imgdata: { num: 0, ix:  8, iy :  9, height: 16 } },
		{	fname:	"sea41",  hidden: true, imgdata: { num: 0, ix:  6, iy :  8, height: 16 } },

		{	fname:	"shoal1",   hidden: true, imgdata: { num: 0, ix: 10, iy :  8, height: 16 } },
		{	fname:	"shoal17",  hidden: true, imgdata: { num: 0, ix:  5, iy :  7, height: 16 } },
		{	fname:	"shoal129", hidden: true, imgdata: { num: 0, ix:  6, iy :  7, height: 16 } },
		{	fname:	"shoal145", hidden: true, imgdata: { num: 0, ix: 20, iy :  2, height: 16 } },
		{	fname:	"shoal2",   hidden: true, imgdata: { num: 0, ix: 26, iy :  4, height: 16 } },
		{	fname:	"shoal34",  hidden: true, imgdata: { num: 0, ix: 25, iy :  5, height: 16 } },
		{	fname:	"shoal18",  hidden: true, imgdata: { num: 0, ix:  7, iy :  7, height: 16 } },
		{	fname:	"shoal50",  hidden: true, imgdata: { num: 0, ix: 16, iy :  1, height: 16 } },
		{	fname:	"shoal4",   hidden: true, imgdata: { num: 0, ix: 23, iy :  4, height: 16 } },
		{	fname:	"shoal68",  hidden: true, imgdata: { num: 0, ix: 20, iy :  3, height: 16 } },
		{	fname:	"shoal36",  hidden: true, imgdata: { num: 0, ix: 19, iy :  3, height: 16 } },
		{	fname:	"shoal100", hidden: true, imgdata: { num: 0, ix: 16, iy :  0, height: 16 } },
		{	fname:	"shoal8",   hidden: true, imgdata: { num: 0, ix: 27, iy :  4, height: 16 } },
		{	fname:	"shoal136", hidden: true, imgdata: { num: 0, ix:  8, iy :  7, height: 16 } },
		{	fname:	"shoal72",  hidden: true, imgdata: { num: 0, ix: 26, iy :  5, height: 16 } },
		{	fname:	"shoal200", hidden: true, imgdata: { num: 0, ix: 20, iy :  1, height: 16 } },
		{	fname:	"shoal3",   hidden: true, imgdata: { num: 0, ix: 16, iy :  9, height: 16 } },
		{	fname:	"shoal35",  hidden: true, imgdata: { num: 0, ix: 28, iy :  5, height: 16 } },
		{	fname:	"shoal131", hidden: true, imgdata: { num: 0, ix: 16, iy :  9, height: 16 } },
		{	fname:	"shoal163", hidden: true, imgdata: { num: 0, ix: 18, iy :  2, height: 16 } },
		{	fname:	"shoal6",   hidden: true, imgdata: { num: 0, ix: 12, iy :  6, height: 16 } },
		{	fname:	"shoal70",  hidden: true, imgdata: { num: 0, ix: 14, iy :  8, height: 16 } },
		{	fname:	"shoal22",  hidden: true, imgdata: { num: 0, ix: 10, iy :  7, height: 16 } },
		{	fname:	"shoal86",  hidden: true, imgdata: { num: 0, ix: 17, iy :  1, height: 16 } },
		{	fname:	"shoal12",  hidden: true, imgdata: { num: 0, ix: 13, iy :  6, height: 16 } },
		{	fname:	"shoal140", hidden: true, imgdata: { num: 0, ix: 11, iy :  7, height: 16 } },
		{	fname:	"shoal44",  hidden: true, imgdata: { num: 0, ix: 13, iy :  8, height: 16 } },
		{	fname:	"shoal172", hidden: true, imgdata: { num: 0, ix: 19, iy :  1, height: 16 } },
		{	fname:	"shoal9",   hidden: true, imgdata: { num: 0, ix: 16, iy :  7, height: 16 } },
		{	fname:	"shoal25",  hidden: true, imgdata: { num: 0, ix: 15, iy :  9, height: 16 } },
		{	fname:	"shoal73",  hidden: true, imgdata: { num: 0, ix: 29, iy :  5, height: 16 } },
		{	fname:	"shoal89",  hidden: true, imgdata: { num: 0, ix: 21, iy :  2, height: 16 } },
		{	fname:	"shoal7",   hidden: true, imgdata: { num: 0, ix: 24, iy :  2, height: 16 } },
		{	fname:	"shoal14",  hidden: true, imgdata: { num: 0, ix: 25, iy :  2, height: 16 } },
		{	fname:	"shoal13",  hidden: true, imgdata: { num: 0, ix: 23, iy :  2, height: 16 } },
		{	fname:	"shoal11",  hidden: true, imgdata: { num: 0, ix: 27, iy :  3, height: 16 } },

		{	fname:	"river3",   hidden: true, land: true, imgdata: { num: 0, ix:  6, iy :  6, height: 16 } },
		{	fname:	"river6",   hidden: true, land: true, imgdata: { num: 0, ix:  4, iy :  5, height: 16 } },
		{	fname:	"river12",  hidden: true, land: true, imgdata: { num: 0, ix:  5, iy :  5, height: 16 } },
		{	fname:	"river9",   hidden: true, land: true, imgdata: { num: 0, ix:  7, iy :  6, height: 16 } },
		{	fname:	"river7",   hidden: true, land: true, imgdata: { num: 0, ix:  4, iy :  3, height: 16 } },
		{	fname:	"river23",  hidden: true, land: true, imgdata: { num: 0, ix:  8, iy :  5, height: 16 } },
		{	fname:	"river39",  hidden: true, land: true, imgdata: { num: 0, ix:  6, iy :  4, height: 16 } },
		{	fname:	"river14",  hidden: true, land: true, imgdata: { num: 0, ix:  0, iy :  2, height: 16 } },
		{	fname:	"river46",  hidden: true, land: true, imgdata: { num: 0, ix: 20, iy :  6, height: 16 } },
		{	fname:	"river78",  hidden: true, land: true, imgdata: { num: 0, ix: 21, iy :  6, height: 16 } },
		{	fname:	"river13",  hidden: true, land: true, imgdata: { num: 0, ix:  5, iy :  3, height: 16 } },
		{	fname:	"river77",  hidden: true, land: true, imgdata: { num: 0, ix:  7, iy :  4, height: 16 } },
		{	fname:	"river141", hidden: true, land: true, imgdata: { num: 0, ix:  9, iy :  5, height: 16 } },
		{	fname:	"river11",  hidden: true, land: true, imgdata: { num: 0, ix:  1, iy :  2, height: 16 } },
		{	fname:	"river139", hidden: true, land: true, imgdata: { num: 0, ix: 24, iy :  7, height: 16 } },
		{	fname:	"river27",  hidden: true, land: true, imgdata: { num: 0, ix: 23, iy :  7, height: 16 } },
		{	fname:	"river15",  hidden: true, land: true, imgdata: { num: 0, ix:  1, iy :  1, height: 16 } },
	]

	var Country_indextable = [];
	for (var i = 0 ; i < Country.length ; i++) {
		var c = Country[i];
		Country_indextable[c.fname] = i;
		if (c.npc) {
			continue;
		}
		c.image = [];
		c.toolrect = new Rect(Toolpx + ((i - 1) % Tool_terrain_xnum) * Tool_terrain_space, Tool_button_height + Tool_mode_height + Toolpy + Math.floor(i / Tool_terrain_xnum) * Tool_terrain_space, Sqsize, Sqsize);
		c.image = new Image();
		c.image.src = "image/button/" + c.fname + ".png";
	}

	var Country_unitdirection = [];
	for (var i = 0 ; i < Country.length ; i++) {
		var c = Country[i];
		var cdir = Country_unitdirection[i] = {};
		if (c.npc) {
			continue;
		}
		cdir.image = [];
		cdir.toolrect = new Rect(Toolpx + (i % Tool_terrain_xnum) * Tool_terrain_space, Tool_button_height + Tool_mode_height + 30 + Toolpy + Math.floor(i / Tool_terrain_xnum) * Tool_terrain_space, Sqsize, Sqsize);
		cdir.image = new Image();
		cdir.image.src = "image/unit/infantry_" + c.fname + ".png";
	}

	var lockbutton = {};
  lockbutton.toolrect = new Rect(Toolpx + 6 * Tool_terrain_space, Tool_button_height + Tool_mode_height + Toolpy, Sqsize, Sqsize);
	lockbutton.image = [];
	lockbutton.image[0] = new Image();
	lockbutton.image[0].src = "image/button/lock.png";
	lockbutton.image[1] = new Image();
	lockbutton.image[1].src = "image/button/unlock.png";

	var Terrain_indextable = {};
	var Maptype = [
		{ fname: "normal" },
	];

	var terrainimg = [];
	for (var i = 0 ; i < 5 ; i++) {
		terrainimg[i] = [];
		for (var k = 0 ; k < Maptype.length ; k++) {
			terrainimg[i][k] = new Image();
 			terrainimg[i][k].src = "image/terrain/" + Maptype[k].fname + "/images" + i + ".png";
		}
	}
	
	var lx = 0;
	var ly = 0;
	for (var i = 0 ; i < Terrain.length ; i++) {
		var t = Terrain[i];
		Terrain_indextable[t.fname] = i;
		t.image = [];
		t.cimage = [];
		t.toolrect = new Rect(Toolpx + lx * Tool_terrain_space, Toolheight + Toolpy + ly * Tool_terrain_space, Sqsize, Sqsize);
		for (var j = 0 ; j < Maptype.length ; j++) {
			t.image[j] = new Image();
			t.image[j].src = "image/terrain/" + Maptype[j].fname + "/" + t.fname + ".png";
			if (t.connect) {
				t.cimage[j] = [];
				for (var k = 0 ; k < 16 + ((t.fname == "sea") ? 8 : 0) + ((t.fname == "shoal") ? 24 : 0) ; k++) {
					t.cimage[j][k] = new Image();
				  t.cimage[j][k].src = "image/terrain/" + Maptype[j].fname + "/" + t.fname + k + ".png";
				}
			}
			if (t.fname == "plain_pd" || t.fname == "pipe_c" || t.fname == "bridge") {
				t.cimage[j] = [];
				t.cimage[j][0] = new Image();
			  t.cimage[j][0].src = "image/terrain/" + Maptype[j].fname + "/" + t.fname + "h.png";
				t.cimage[j][1] = new Image();
			  t.cimage[j][1].src = "image/terrain/" + Maptype[j].fname + "/" + t.fname + "v.png";
			}
			if (t.fname == "plain_pd") {
				t.cimage[j][2] = new Image();
			  t.cimage[j][2].src = "image/terrain/" + Maptype[j].fname + "/" + t.fname + ".png";
			}
		}
		lx++;
		if (t.space) {
			lx += t.space;
		}
		if (lx >= Tool_terrain_xnum) {
			lx = 0;
			ly++;
		}
	}
	Toolheight += Toolpy + 2 * Tool_terrain_space + Tool_building_margin;
	for (var j = 0 ; j < Country.length ; j++) {
		for (var i = 0 ; i < Building.length ; i++) {
			var b = Building[i];
			if (b.hq == true && Country[j].npc) {
				continue;
			}
			var t = Terrain[Terrain.length] = {};
			t.image = [];
			var bkeys = Object.keys(b);
			for (var key in bkeys) {
				t[bkeys[key]] = b[bkeys[key]];
			}
			t.country = Country[j].fname;
			t.countryid = j;
			t.toolrect = new Rect(Toolpx + i * Tool_terrain_space, Toolheight + j * Tool_terrain_space, Sqsize, Sqsize);
			for (var k = 0 ; k < Maptype.length ; k++) {
				t.fname += "_" + Country[j].fname
				Terrain_indextable[t.fname] = Terrain.length - 1;
				t.image[k] = new Image();
		  	t.image[k].src = "image/terrain/" + Maptype[k].fname + "/" + t.fname + ".png";
			}
		}
	}
	var Extratoolindex = Terrain.length;
	var lx = 0;
	var ly = 0;
	for (var i = 0 ; i < Extra.length ; i++) {
		var e = Extra[i];
		var t = Terrain[Terrain.length] = {};
		var ekeys = Object.keys(e);
		for (var key of ekeys) {
			t[key] = e[key];
		}
		t.extra = true;
		t.toolrect = new Rect(Toolpx + lx * Tool_terrain_space, Tool_button_height + Tool_mode_height + Toolpy + ly * Tool_terrain_space, Sqsize, Sqsize);
		t.image = [];
		Terrain_indextable[t.fname] = Terrain.length - 1;
		for (var k = 0 ; k < Maptype.length ; k++) {
			t.image[k] = new Image();
			t.image[k].src = "image/terrain/" + Maptype[k].fname + "/" + t.fname + ".png";
		}
		if (t.large == true) {
			for (var y = 0 ; y < t.size ; y++) {
				for (var x = 0 ; x < t.size ; x++) {
					var t2 = Terrain[Terrain.length] = {};
					t2.image = [];
					for (var key of ekeys) {
						t2[key] = t[key];
					}
					t2.x = x;
					t2.y = y;
					t2.hidden = true;
					if (x === t2.destroyx && y === t2.destroyy) {
						t2.candestroy = true;
						t2.hp = 99;
					}
					for (var k = 0 ; k < Maptype.length ; k++) {
						t2.fname += x + "" + y;
						Terrain_indextable[t2.fname] = Terrain.length - 1;
						t2.image[k] = t.image[k];
					}
				}
			}
		}
		lx++;
		if (e.space) {
			lx += e.space;
		}
		if (e.newline || lx >= Tool_terrain_xnum) {
			lx = 0;
			ly++;
		}
	}
	Toolheight = Tool_button_height + Tool_mode_height + 9 * Tool_terrain_space + Toolpy;

	var UnitList = [
		{	fname:	"infantry" },
		{	fname:	"mech" },
		{	fname:	"apc" },
		{	fname:	"oozium", space: 1 },
		{	fname:	"delete", deletebutton: true, newline: true },
		{	fname:	"recon" },
		{	fname:	"tank" },
		{	fname:	"mdtank" },
		{	fname:	"neotank" },
		{	fname:	"megatank" },
		{	fname:	"antiair", newline: true },
		{	fname:	"artillery" },
		{	fname:	"rocket" },
		{	fname:	"missle" },
		{	fname:	"piperunner", newline: true },
		{	fname:	"tcopter" },
		{	fname:	"bcopter" },
		{	fname:	"fighter" },
		{	fname:	"bomber" },
		{	fname:	"stealth" },
		{	fname:	"blackbomb", newline: true },
		{	fname:	"blackboat" },
		{	fname:	"lander" },
		{	fname:	"cruiser" },
		{	fname:	"battleship" },
		{	fname:	"carrier" },
		{	fname:	"sub" },
	]

	var Unit_indextable = [];
	var Unit = [];
	for (var j = 0 ; j < Country.length ; j++) {
		var c = Country[j];
		if (c.npc) {
			continue;
		}
		var lx = 0;
		var ly = 0;
		for (var i = 0 ; i < UnitList.length ; i++) {
			var ul = UnitList[i];
			var index = Unit.length;
			var u = Unit[Unit.length] = {};
			var ekeys = Object.keys(ul);
			for (var key of ekeys) {
				u[key] = ul[key];
			}
			u.uname = u.fname;
			u.fname += "_" + c.fname;
			u.country = c.fname;
			Unit_indextable[u.fname] = index;
			u.image = [];
			u.toolrect = new Rect(Toolpx + lx * Tool_terrain_space, Tool_button_height + Tool_mode_height + Tool_country_height + 30 + Toolpy + ly * Tool_terrain_space, Sqsize, Sqsize);
			u.image = new Image();
			if (u.deletebutton) {
			  u.image.src = "image/button/" + u.uname + ".png";
			}
			else {
			  u.image.src = "image/unit/" + u.fname + ".png";
			}
			lx++;
			if (u.space) {
				lx += u.space;
			}
			if (lx >= Tool_terrain_xnum || u.newline) {
				lx = 0;
				ly++;
			}
		}
	}

	var changesizeimg = new Image();
	changesizeimg.src = "image/button/changesize.png";

	function FWEditor(canvasid) {
		var id = getmyid();

		this.Toolmode = "Terrain";
		this.Tool_select = 0;
		this.Tool_country_select = 0;
		this.Tool_unit_lock = true;

		this.resizedrag = false;

		this.savedata = {
			fwmapdataver:	2,
			mapdata: {},
			countrydata: {},
		};

		this.canvas = document.getElementById(canvasid);
		this.canvas.me = this;
		if (!this.canvas || !this.canvas.getContext) {
			this.canuse = false;
			return;
 		}
		this.canuse = true;
		this.ctx = this.canvas.getContext('2d');

		this.canvas.onmousemove = function(evt) {
			var me = this.me;
			var rect = this.getBoundingClientRect();
			var mx, my;
			me.mx = mx = Math.floor(evt.clientX - rect.left);
			me.my = my = Math.floor(evt.clientY - rect.top);
			var dragx = me.dragx;
			var dragy = me.dragy;
			var Toolmode = me.Toolmode;
			var Tool_select = me.Tool_select;
			if (me.usetool) {
				var cx = Math.floor(mx / Sqsize);
				var cy = Math.floor(my / Sqsize);
				if (Toolmode == "Terrain" || Toolmode == "Extra") {
					if (evt.buttons & 1) {
						me.setmap(cx, cy, Toolmode == "Terrain" ? me.TerrainUI.getselectdata().name : me.ExtraUI.getselectdata().name);
					}
					else if (evt.buttons & 2) {
						var fromx = (cx < dragx) ? cx : dragx;
						var fromy = (cy < dragy) ? cy : dragy;
						var tox = (cx > dragx) ? cx : dragx;
						var toy = (cy > dragy) ? cy : dragy;
						var data = (Toolmode === "Terrain") ? me.TerrainUI.getselectdata() : me.ExtraUI.getselectdata();
						var tname = data.name;
						var t = Terrain_imglist[tname];
						var plus = (t.large) ? t.size : 1;
						me.restoremap();
						for (var x = dragx ; (dragx < cx) ? x <= cx : x >= cx ; x += plus * ((dragx < cx) ? 1 : -1)) {
							for (var y = dragy ; (dragy < cy) ? y <= cy : y >= cy ; y += plus * ((dragy < cy) ? 1 : -1)) {
								me.setmap(x, y, tname);
							}
						}
					}
				}
				else if (Toolmode == "Unit") {
					if (evt.buttons & 1) {
						var selunit = me.findunit(cx, cy);
						if (selunit !== false && (Unit[Tool_select].deletebutton || me.Tool_unit_lock === false)) {
							me.deleteunit(selunit.country, selunit.index);
						}
						if (!Unit[Tool_select].deletebutton && me.findunit(cx, cy) === false) {
							me.setunit(cx, cy, Tool_select);
						}
						me.setunitmap();
					}
					else if (evt.buttons & 2) {
						var selunit = me.findunit(cx, cy);
						if (selunit !== false) {
							me.deleteunit(selunit.country, selunit.index);
						}
						me.setunitmap();
					}
				}
				else if (Toolmode == "Map") {
					if (me.resizedrag) {
						var w = Math.floor(mx / Sqsize) + 1;
						var h = Math.floor(my / Sqsize) + 1;
						if (!(w <= 0 || w > Maxwidth || h <= 0 || h > Maxheight)) {
							if (me.savedata.mapdata.width != w && me.savedata.mapdata.height != h) {
								me.init(w, h, false);
							}
						}
					}
				}
			}
			me.draw();
		}
		this.canvas.onmousedown = function(evt) {
			var rect = this.getBoundingClientRect();
			var me = this.me;
			var map = me.savedata.mapdata.map;
			var tx = me.tx;
			var ty = me.ty;
			var mx, my;
			var Toolmode = me.Toolmode;
			var Tool_select = me.Tool_select;

			me.mx = mx = Math.floor(evt.clientX - rect.left);
			me.my = my = Math.floor(evt.clientY - rect.top);

			if (me.usetool) {
				var d = me.ButtonUI.getclickdata(mx - tx, my - ty);
				if (d) {
					if (d.name == "new") {
						me.init(me.savedata.mapdata.width, me.savedata.mapdata.height, true);
						me.draw();
					}
					else if (d.name == "open") {
						var input = document.createElement("input");
						input.type = "file"
						input.me = me;
						input.onchange = function(e) {
							var me = this.me;
							var map = me.savedata.mapdata.map;
							if (this.files.length > 0){
								var f = this.files[0];
								var reader = new FileReader();
								reader.me = me;
								reader.onload = (function(file) {
									var me = this.me;
									var loaddata = JSON.parse(file.target.result);
									if (loaddata && loaddata.fwmapdataver) {
										if (loaddata.fwmapdataver == 1) {
											me.savedata.fwmapdataver = 2;
											me.savedata.mapdata.width = loaddata.width;
											me.savedata.mapdata.height = loaddata.height;
											me.savedata.mapdata.maptype = 0;
											me.init(me.savedata.mapdata.width, me.savedata.mapdata.height, true);
											var map = me.savedata.mapdata.map = loaddata.map;
											for (var i = 0 ; i < Country.length - 1 ; i++) {
												var c = Country[i];
												if (c.npc) {
													continue;
												}
												if (loaddata.unitdata !== undefined) {
													me.savedata.countrydata[c.fname].unitdata = loaddata.unitdata[c.fname];
												}
												else {
													me.savedata.countrydata[c.fname].unitdata = [];
												}
											}
										}
										else {
											me.savedata = loaddata;
											me.init(me.savedata.mapdata.width, me.savedata.mapdata.height, false);
										}
										me.setunitmap();
										me.draw();
									}
									else {
										alert("ファイルの形式が違います");
									}
								});
								reader.readAsText(f);	
							}
						}
						input.click();
					}
					else if (d.name == "save") {
						var blob = new Blob([JSON.stringify(me.savedata, null, ' ')], {type: "application/json"});
						var a = document.createElement("a");
						a.href = URL.createObjectURL(blob);
						document.body.appendChild(a);
						a.target = "_blank";
						a.download = "save.json";
						a.click();
						document.body.removeChild(a);
					}
				}
				var d = me.ModeUI.getclickdata(mx - tx, my - ty);
				if (d) {
					me.ModeUI.selectdata(d);
					me.Toolmode = Toolmode = d.name;
					if (Toolmode == "Extra") {
						me.Tool_select = Extratoolindex;
					}
					me.Tool_country_select = 0;
				}
				if (Toolmode == "Terrain" || Toolmode == "Extra") {
					if (evt.buttons & 2) {
						me.backupmap();
						me.dragx = Math.floor(mx / Sqsize);
						me.dragy = Math.floor(my / Sqsize);
					}
				}
				if (Toolmode == "Unit") {
					if (lockbutton.toolrect.isinside(mx - tx, my - ty)) {
						me.Tool_unit_lock = !me.Tool_unit_lock;
					}
					var d = me.UnitCountryUI.getclickdata(mx - tx, my - ty);
					if (d) {
						me.UnitCountryUI.selectdata(d);
						for (var j = 0 ; j < Unit.length ; j++) {
							if (Unit[Tool_select].uname == Unit[j].uname && d.name == Unit[j].country) {
								me.Tool_select = Tool_select = j;
								break;
							}
						}
					}

					for (var i = 0 ; i < Country.length ; i++) {
						var c = Country[i];
						var cdir = Country_unitdirection[i];
						if (c.npc) {
							continue;
						}
						if (cdir.toolrect.isinside(mx - tx, my - ty)) {
							me.savedata.countrydata[c.fname].unitdirection = (me.savedata.countrydata[c.fname].unitdirection == "right") ? "left" : "right";
							break;
						}
					}
				}
				else if (Toolmode == "Map") {
					var r = new Rect((me.savedata.mapdata.width - 0.5) * Sqsize, (me.savedata.mapdata.height - 0.5) * Sqsize, Sqsize, Sqsize);
					if (r.isinside(mx, my)) {
						me.resizedrag = true;
					}
					var d = me.MapsizeUI.getclickdata(mx - tx, my - ty);
					if (d) {
						if (d.name == "param.savedata.mapdata.width" || d.name == "param.savedata.mapdata.height") {
							var msg = (d.name == "param.savedata.mapdata.width") ? "幅" : "高さ";
							var def = (d.name == "param.savedata.mapdata.width") ? me.savedata.mapdata.width : me.savedata.mapdata.height;
							var num = window.prompt(msg, def);
							if (num !== null) {
								num = +num;
								if (num <= 0 || num > 100 || isNaN(num)) {
									alert("1～100の値を入力してください");
								}
								else {
									var w = (d.name == "param.savedata.mapdata.width") ? Math.floor(num) : me.savedata.mapdata.width;
									var h = (d.name == "param.savedata.mapdata.height") ? Math.floor(num) : me.savedata.mapdata.height;
									me.init(w, h, false);
								}
							}
						}
					}
				}
				this.onmousemove(evt);
				if (Toolmode == "Terrain") {
					var d = me.TerrainUI.getclickdata(mx - tx, my - ty);
					if (d) {	
						me.TerrainUI.selectdata(d);
					}
				}
				else if (Toolmode == "Extra") {
					var d = me.ExtraUI.getclickdata(mx - tx, my - ty);
					if (d) {	
						me.ExtraUI.selectdata(d);
					}
				}
else {
				var data = me.getdatafromtoolmode();
				for (var i = 0 ; i < data.length ; i++) {
					var t = data[i];
					if ((Toolmode == "Terrain" && t.extra) || (Toolmode == "Extra" && !t.extra)) {
						continue;
					}
					if (Toolmode == "Unit" && t.country != me.UnitCountryUI.getselectdata().name) {
						continue;
					}
					if (t.hidden != true && t.toolrect.isinside(mx - tx, my - ty)) {
						me.Tool_select = Tool_select = i;
						break;
					}
				}
}
			}
			me.draw();
		}
		this.canvas.onmouseup = function(evt) {
			var me = this.me;
			var rect = this.getBoundingClientRect();
			me.mx = Math.floor(evt.clientX - rect.left);
			me.my = Math.floor(evt.clientY - rect.top);
			this.me.resizedrag = false;
			me.draw();
		}
		this.canvas.addEventListener('DOMMouseScroll', mouseWheelEvent);
		this.canvas.onmousewheel = function(evt) {
			mouseWheelEvent(evt);
		}
		function mouseWheelEvent(evt) {
			var me = this.me;
			var delta = evt.wheelDelta ? evt.wheelDelta : evt.detail;
			var data = me.getdatafromtoolmode();
			var Toolmode = me.Toolmode;
			if (delta > 0) {
				if (Toolmode == "Terrain") {
					me.TerrainUI.selectnext();
				}
				if (Toolmode == "Extra") {
					me.ExtraUI.selectnext();
				}
				while (1) {
					me.Tool_select++;
					if (data.length <= me.Tool_select) {
						me.Tool_select = 0;
						break;
					}
					var t = data[me.Tool_select];
					if (t.x !== undefined) {
						continue;
					}
					if ((Toolmode == "Terrain" && t.extra) || (Toolmode == "Extra" && !t.extra)) {
						continue;
					}
					if (Toolmode == "Unit" && t.country != Country[me.Tool_country_select].fname) {
						continue;
					}
					break;
				}
			}
			else {
				while (1) {
					if (Toolmode == "Terrain") {
						me.TerrainUI.selectprev();
					}
					if (Toolmode == "Extra") {
						me.ExtraUI.selectprev();
					}
					break;
					me.Tool_select--;
					if (me.Tool_select < 0) {
						me.Tool_select = data.length - 1;
					}
					var t = data[me.Tool_select];
					if (t.x !== undefined) {
						continue;
					}
					if ((Toolmode == "Terrain" && t.extra) || (Toolmode == "Extra" && !t.extra)) {
						continue;
					}
					if (Toolmode == "Unit" && t.country != Country[me.Tool_country_select].fname) {
						continue;
					}
					break;
				}
			}
			me.draw();
		}
		this.canvas.onmouseout = function(evt) {
			var me = this.me;
			me.resizedrag = false;
			me.draw();
		}
		this.canvas.oncontextmenu = function(evt) {
			return false;
		}
	
		this.usetool = true;

		this.getversion = function() {
			return version;
		}
		this.getlastupdate = function() {
			return lastupdate;
		}
		this.getsize = function() {
			return { width: this.savedata.mapdata.width, height: this.savedata.mapdata.height }
		};
		this.setsize = function(w, h, clear) {
			if (w <= 0 || w > Maxwidth) {
				w = Defaultwidth;
			}
			if (h <= 0 || h > Maxheight) {
				h = Defaultheight;
			}
			var newmap = [];
			this.mapbeforedrag = [];
			for (var x = 0 ; x < w ; x++) {
				newmap[x] = [];
				this.mapbeforedrag[x] = [];
				for (var y = 0 ; y < h ; y++) {
					if (!clear && x < this.savedata.mapdata.width && y < this.savedata.mapdata.height) {
						newmap[x][y] = this.savedata.mapdata.map[x][y];
					}
					else {
						newmap[x][y] = "plain";
					}
					this.mapbeforedrag[x][y] = 0;
				}
			}
			this.savedata.mapdata.map = newmap;

			if (clear) {
				for (var i = 0 ; i < Country.length ; i++) {
					var c = Country[i];
					if (c.npc) {
						continue;
					}
					var cdata = this.savedata.countrydata[c.fname];
					cdata.front.shogun = null;
					cdata.front.bp = 0;
					cdata.back.shogun = null;
					cdata.back.bp = 0;
					cdata.money = 0;
					cdata.unitdirection = "right";
					cdata.unitdata = [];
				}
			}
			else {
				for (var i = 0 ; i < Country.length ; i++) {
					var c = Country[i];
					if (c.npc) {
						continue;
					}
					var u = this.savedata.countrydata[c.fname].unitdata;
					for (var j = 0 ; j < u.length ; j++) {
						if (!(u[j].x < w && u[j].y < h)) {
							u.splice(j, 1);
							j--;
						}
					}
				}
			}
			this.savedata.mapdata.width = w;
			this.savedata.mapdata.height = h;
			this.setunitmap();
		}

		this.getdatafromtoolmode = function() {
			if (this.Toolmode == "Terrain" || this.Toolmode == "Extra") {
				return Terrain;
			}
			else {
				return Unit;
			}
		}

		this.findunit = function(x, y) {
			for (var i = 0 ; i < Country.length ; i++) {
				var c = Country[i];
				if (c.npc) {
					continue;
				}
				var udata = this.savedata.countrydata[c.fname].unitdata;
				for (var j = 0 ; j < udata.length ; j++) {
					var u = udata[j];
					if (u.x == x && u.y == y) {
						return { country: c.fname, index: j };
					}
				}
			}
			return false;
		}

		this.setunit = function(x, y, tid, check) {
			if (this.isinside(x, y)) {
				var c = Unit[tid].country;
				this.savedata.countrydata[c].unitdata.push({ x: x, y: y, fname: Unit[tid].fname });
			}
		}	

		this.deleteunit = function(cname, index) {
			if (!this.savedata.countrydata[cname].unitdata) {
				return;
			}
			this.savedata.countrydata[cname].unitdata.splice(index, 1);
		}

		this.setunitmap = function() {
			var unitmap = this.unitmap = [];
			for (var x = 0 ; x < this.savedata.mapdata.width ; x++) {
				unitmap[x] = [];
				for (var y = 0 ; y < this.savedata.mapdata.height ; y++) {
					unitmap[x][y] = null;
				}
			}
			for (var i = 0 ; i < Country.length ; i++) {
				var c = Country[i];
				if (c.npc) {
					continue;
				}
				var udata = this.savedata.countrydata[c.fname].unitdata;
				for (var j = 0 ; j < udata.length ; j++) {
					var u = udata[j];
					unitmap[u.x][u.y] = u.fname;
				}
			}
		}

		this.drawterrain = function(tname, dx, dy, x, y, c, img) {
			var ctx = this.ctx;
			var map = this.savedata.mapdata.map;
			var t = Terrain_imglist[tname];
//			if (t.land) {
//				ctx.drawImage(Terrain[Terrain_indextable["plain"]].image[this.savedata.mapdata.maptype], dx, dy);
//			}
//			if (t.large) {
//				ctx.drawImage(img, t.x * Sqsize, t.y * Sqsize, Sqsize, Sqsize, dx, dy, Sqsize, Sqsize);
//			}
//			else {
//				if (t.imgdata) {
			var t2;
			if (t.connect && c !== null) {
				if (tname == "wideriver") {
					t2 = Terrain_imglist["river" + c];
				}
				else {
					t2 = Terrain_imglist[tname + c];
				}
			}
			else {
				t2 = t;
			}
			if (x > 0 && t2.receiveshadow && Terrain[Terrain_indextable[map[x - 1][y]]].shadow) {
				ctx.drawImage(terrainimg[t2.imgdata.num][this.savedata.mapdata.maptype], t2.imgdata.sx * Sqsize, t2.imgdata.sy * Sqsize, Sqsize, t2.imgdata.height, dx, dy + Sqsize - t2.imgdata.height, Sqsize, t2.imgdata.height);
			}
			else {
				if (t2.imgdata.num2 !== undefined) {
					ctx.drawImage(terrainimg[t2.imgdata.num2][this.savedata.mapdata.maptype], t2.imgdata.ix2 * Sqsize, t2.imgdata.iy2 * Sqsize, Sqsize, Sqsize, dx, dy - Sqsize, Sqsize, Sqsize);
					ctx.drawImage(terrainimg[t2.imgdata.num][this.savedata.mapdata.maptype], t2.imgdata.ix * Sqsize, t2.imgdata.iy * Sqsize, Sqsize, Sqsize, dx, dy, Sqsize, Sqsize);
				}
				else {
					if (t2.large) {
						ctx.drawImage(terrainimg[t2.imgdata.num][this.savedata.mapdata.maptype], t2.imgdata.ix * Sqsize, t2.imgdata.iy * Sqsize, t2.imgdata.height, t2.imgdata.height, dx, dy, Sqsize, Sqsize);
					}
					else {
						ctx.drawImage(terrainimg[t2.imgdata.num][this.savedata.mapdata.maptype], t2.imgdata.ix * Sqsize, t2.imgdata.iy * Sqsize, Sqsize, t2.imgdata.height, dx, dy + Sqsize - t2.imgdata.height, Sqsize, t2.imgdata.height);
					}
				}
			}
		}

		this.drawmap = function() {
			var ctx = this.ctx;
			var map = this.savedata.mapdata.map;
			var Toolmode = this.Toolmode;
			for (var y = 0 ; y < this.savedata.mapdata.height ; y++) {
				for (var x = 0 ; x < this.savedata.mapdata.width ; x++) {
					var tname = map[x][y];
					var t = Terrain_imglist[tname];//Terrain[Terrain_indextable[map[x][y]]];
					var img;
					if (t.connect) {
						var c = 0;
						var count = 0;
						var dx = [ 0, 1, 0, -1 ];
						var dy = [ -1, 0, 1, 0 ];
						var di = [ 1, 3, 0, 2 ];
						var isshoal = [];
						for (var i = 0 ; i < 4 ; i++) {
							var x2 = x + dx[di[i]];
							var y2 = y + dy[di[i]];
							isshoal[di[i]] = false;
							if (this.isinside(x2, y2)) {
								var tname2 = map[x2][y2];
								var t2 = Terrain_imglist[tname2];
								if (tname2 == "shoal") {
									isshoal[di[i]] = true;
								}
								if ((tname2 == "road" && tname2 == "road") || 
										(tname == "bridge" && (tname2 == "bridge" || t2.land != true)) ||
										(tname == "river" && tname2 == "river") ||
										(tname == "wideriver" && (tname2 == "wideriver" || t2.sea)) ||
										(tname == "sea" && t2.land == true) ||
										(tname == "shoal" && t2.land == true && (tname2 != "river" && tname2 != "wideriver")) ||
										(t.pipe == true && t2.pipe == true && !(tname == "plain_pd" && tname2 == "plain_pd"))) {
									if (i >= 4) {
										if (tname == "river") {
											if (c & (1 << (i % 4)) || c & (1 << (i + 1) % 4)) {
												continue;
											}
										}
									}
									c += (1 << di[i]);
									count++;
								}
							}
							if (count == 2) {
								if (t.pipe == true) {
									if (tname == "pipe") {
										break;
									}
									else if (c == 10) {
										c = "h";
									}
									else if (c == 5) {
										c = "v";
									}
									else if (tname == "pipe_c") {
										map[x][y] = "pipe";
										tname = "pipe";
										t = Terrain_imglist["pipe"];
									}
									else if (tname == "plain_pd") {
										c = "";
									}
									break;
								}
							}
						}
						if (count == 0 && tname == "pipe") {
							c = 10;
						}
						if (count <= 1 && tname == "road") {
							if (c == 1 || c == 4) {
								c = 5;
							}
							else {
								c = 10;
							}
						}
						if (tname == "river" || tname == "wideriver" || tname == "sea") {
							if (tname == "river" || tname == "wideriver") {
								if (c == 0) {
									c = 10;
								}
								else if (count == 1) {
									if (c == 1 || c == 4) {
										c = 5;
									}
									else {
										c = 10;
									}
								}
							}
							if (!((tname == "river" || tname == "wideriver") && (c == 5 || c == 10))) {
								var dx = [ 0, 1, 1, 1, 0, -1, -1, -1 ];
								var dy = [ -1, -1, 0, 1, 1, 1, 0, -1 ];
								var island = [];
								var isriver = [];
								var issameriver = [];
								var ismouthriver = [];
								var issea = [];
								for (var i = 0 ; i < 8 ; i++) {
									var x2 = x + dx[i];
									var y2 = y + dy[i];
									island[i] = isriver[i] = issameriver[i] = ismouthriver[i] = issea[i] = false;
									if (this.isinside(x2, y2)) {
										var tname2 = map[x2][y2];
										var t2 = Terrain_imglist[tname2];
										if (t2.land == true) {
											island[i] = true;
										}
										if (t2.sea == true) {
											issea[i] = true;
										}
										if ((tname2 == "river" || tname2 == "wideriver") && (tname == "sea" || tname == tname2)) {
											if (tname2 == "river") {
												isriver[i] = true;
											}
											if (tname == tname2) {
												issameriver[i] = true;
											}
											if (tname2 != "wideriver" && (i == 0 || i == 4)) {
												y2 += dy[i];
												if (this.isinside(x2, y2) && map[x2][y2] == "river") {
													ismouthriver[i] = true;
												}
											}
											else {
												ismouthriver[i] = true;
											}
										}
									}
								}
								for (var i = 0 ; i < 8 ; i += 2) {
									if (tname == "sea" && ismouthriver[i] && (!isriver[i] || (!isriver[(i + 7) % 8] && !isriver[(i + 1) % 8])) && !island[(i + 2) % 8] && !island[(i + 3) % 8] && !island[(i + 4) % 8] && !island[(i + 5) % 8] && !island[(i + 6) % 8]) {
										c = "_r" + (1 << (i / 2));
										break;
									}
									if ((tname == "sea" && !island[i] && island[(i + 1) % 8] && !island[(i + 2) % 8]) ||
											((tname == "river" || tname =="wideriver") && issameriver[i] && (!issameriver[(i + 1) % 8] && !(tname == "wideriver" && issea[(i + 1) % 8])) && issameriver[(i + 2) % 8])) {
										c |= 1 << ((i / 2) + 4);
									}
								}
							}
						}
						if (count < 2 && tname == "pipe_c") {
							map[x][y] = "pipe";
							tname = "pipe";
							t = Terrain_imglist["pipe"];
							c = 10;
						}
						if (tname == "plain_pd" && count != 2) {
								c = "";
						}
						if (tname == "bridge") {
							if (c == 1 || c == 4 || c == 5) {
								c = "v";
							}
							else {
								c = "h";
							}
						}
						if (tname == "wideriver") {
							if (count == 4 && c != 255) {
								c = 15;
							}
						}
						if (tname == "shoal") {
							var dx = [ 1, 1, -1, -1 ];
							var dy = [ -1, 1, 1, -1 ];
							var island = [];
							for (var i = 0 ; i < 4 ; i++) {
								var x2 = x + dx[i];
								var y2 = y + dy[i];
								if (this.isinside(x2, y2) && Terrain_imglist[map[x2][y2]].land == true) {
									island[i] = true;
								}
								else {
									island[i] = false;
								}
							}
							var seaflag = false;
							if (c == 0 || c == 5 || c == 10 || c == 15) {
								seaflag = true;
							}
							for (var i = 0 ; i < 4 ; i++) {
								if (c == 1 << i && (island[(i + 1) % 4] == true || island[(i + 2) % 4] == true)) {
									seaflag = true;
									break;
								}
							}
							if (seaflag == true) {
								map[x][y] = "sea";
								t = Terrain_imglist["sea"];
								tname = "sea";
							}
							else {
								for (var i = 0 ; i < 4 ; i++) {
									if (c == 7 || c == 11 || c == 13 || c == 14) {
										continue;
									}
									if (c & (1 << i)) {
										if (isshoal[(i + 1) % 4] == true) {
											c |= 1 << (i + 4);
										}
										if (isshoal[(i + 3) % 4] == true) {
											c |= 1 << ((i + 3) % 4 + 4);
										}
									}
								}		
							}
						}
					//	img = t.cimage[this.savedata.mapdata.maptype][c];
					}
					else {
					//	img = t.image[this.savedata.mapdata.maptype];
					}
					this.drawterrain(tname, x * Sqsize, y * Sqsize, x, y, c, img);

					var uname = this.unitmap[x][y];
					if (uname !== null) {
						if (this.savedata.countrydata[Unit[Unit_indextable[uname]].country].unitdirection == "right") {
							ctx.drawImage(Unit[Unit_indextable[uname]].image, x * Sqsize, y * Sqsize);
						}
						else {
							ctx.save();
							ctx.scale(-1, 1);
							ctx.translate(-((x + 1) * Sqsize) , 0);
							ctx.drawImage(Unit[Unit_indextable[uname]].image, 0, y * Sqsize);
							ctx.restore();
						}
					}
				}
			}
			if (Toolmode == "Map" && this.resizedrag == true) {
				ctx.beginPath();
				ctx.strokeStyle = "black";
				ctx.lineWidth = 1;
				ctx.rect(0, 0, this.savedata.mapdata.width * Sqsize, this.savedata.mapdata.height * Sqsize);
				ctx.stroke();
			}
		}

		this.copymap = function(from, to) {
			for (var x = 0 ; x < this.savedata.mapdata.width ; x++) {
				to[x] = [];
				for (var y = 0 ; y < this.savedata.mapdata.height ; y++) {
					to[x][y] = from[x][y];
				}
			}
		}
		this.restoremap = function() {
			this.copymap(this.mapbeforedrag, this.savedata.mapdata.map);
		}
		this.backupmap = function() {
			this.copymap(this.savedata.mapdata.map, this.mapbeforedrag);
		}

		this.drawtool = function() {
			var ctx = this.ctx;
			var tx = this.tx;
			var ty = this.ty;
			var Toolmode = this.Toolmode;
			var Tool_select = this.Tool_select;

			this.ButtonUI.draw(ctx, tx, ty, this);
			this.ModeUI.draw(ctx, tx, ty, this);

			if (Toolmode == "Unit") {
				this.UnitCountryUI.draw(ctx, tx, ty, this);
//				var c = Country[this.Tool_country_select + 1];
//				ctx.beginPath();
//				ctx.fillStyle = Tool_select_rectcolor;
//				ctx.rect(tx + c.toolrect.x - (Tool_select_rectsize - Sqsize) / 2, ty + c.toolrect.y - (Tool_select_rectsize - Sqsize) / 2, Tool_select_rectsize, Tool_select_rectsize);
//				ctx.fill();
//				for (var i = 0 ; i < Country.length ; i++) {
//					var c = Country[i];
//					var cdir = Country_unitdirection[i];
//					if (c.npc) {
//						continue;
//					}
//					ctx.drawImage(c.image, tx + c.toolrect.x, ty + c.toolrect.y, Sqsize, Sqsize);
//					if (this.savedata.countrydata[c.fname].unitdirection == "right") {
//						ctx.drawImage(cdir.image, tx + cdir.toolrect.x, ty + cdir.toolrect.y, Sqsize, Sqsize);
//					}
//					else {
//						ctx.save();
//						ctx.scale(-1, 1);
//						ctx.translate(-(tx + cdir.toolrect.x) , 0);
//						ctx.drawImage(cdir.image, -Sqsize, ty + cdir.toolrect.y, Sqsize, Sqsize);
//						ctx.restore();
//					}
//				}
				ctx.drawImage(lockbutton.image[this.Tool_unit_lock ? 0 : 1], tx + lockbutton.toolrect.x, ty + lockbutton.toolrect.y, Sqsize, Sqsize);
			}

			if (Toolmode == "Map") {
				this.MapsizeUI.draw(ctx, tx, ty, this);
				ctx.drawImage(changesizeimg, (this.savedata.mapdata.width - 0.5) * Sqsize, (this.savedata.mapdata.height - 0.5) * Sqsize);
				return;
			}

			if (Toolmode == "Terrain") {
				this.TerrainUI.draw(ctx, tx, ty, this);
				return;
			}
			if (Toolmode === "Extra") {
				this.ExtraUI.draw(ctx, tx, ty, this);
				return;
			}
			var data = this.getdatafromtoolmode();

			ctx.beginPath();
			ctx.fillStyle = Tool_select_rectcolor;
			ctx.rect(tx + data[Tool_select].toolrect.x - (Tool_select_rectsize - Sqsize) / 2, ty + data[Tool_select].toolrect.y - (Tool_select_rectsize - Sqsize) / 2, Tool_select_rectsize, Tool_select_rectsize);
			ctx.fill();

			for (var i = 0 ; i < data.length ; i++) {
				var t = data[i];
				if (t.hidden) {
					continue;
				}
				if ((Toolmode == "Terrain" && t.extra) || (Toolmode == "Extra" && !t.extra)) {
					continue;
				}
				if ((Toolmode == "Unit" && t.country != this.UnitCountryUI.getselectdata().name)) {
					continue;
				}
				if (Toolmode == "Terrain" || Toolmode == "Extra") {
					if (t.large) {
						ctx.drawImage(t.image[this.savedata.mapdata.maptype], tx + t.toolrect.x, ty + t.toolrect.y, Sqsize, Sqsize);
					}
					else {
						this.drawterrain(tname, tx + t.toolrect.x, ty + t.toolrect.y, 0, 0, null, t.image[this.savedata.mapdata.maptype]);
					}
				}
				else {
					if (this.savedata.countrydata[this.UnitCountryUI.getselectdata().name].unitdirection == "right" || t.deletebutton) {
						ctx.drawImage(t.image, tx + t.toolrect.x, ty + t.toolrect.y, Sqsize, Sqsize);
					}
					else {
						ctx.save();
						ctx.scale(-1, 1);
						ctx.translate(-(tx + t.toolrect.x) , 0);
						ctx.drawImage(t.image, -Sqsize, ty + t.toolrect.y, Sqsize, Sqsize);
						ctx.restore();
					}
				}
			}
		}

		this.draw = function() {
			var ctx = this.ctx;
			ctx.fillStyle = "rgb(240, 240, 240)";
			ctx.beginPath();
			ctx.rect(0, 0, this.canvas.width, this.canvas.height);
			ctx.fill();
			this.drawmap();
			if (this.usetool) {
				this.drawtool();
			}
		}

		this.isinside = function(x, y) {
			if (0 <= x && x < this.savedata.mapdata.width && 0 <= y && y < this.savedata.mapdata.height) {
				return true;
			}
			else {
				return false;
			}	
		}

		this.cansetreef = function(x, y) {
			var map = this.map;
			for (var dx = -1 ; dx <= 1 ; dx++) {
				for (var dy = -1 ; dy <= 1 ; dy++) {
					if (dx == 0 && dy == 0) {
						continue;
					}
					var x2 = x + dx;
					var y2 = y + dy;
					if (this.isinside(x2, y2) && Terrain[Terrain_indextable[map[x2][y2]]].land == true) {
						return false;
					}
				}
			}
			return true;
		}

		this.cansetriver = function(x, y) {
			var map = this.savedata.mapdata.map;
			var dx = [ 0, 0, -1, -1 ];
			var dy = [-1, 0, -1, 0 ];
			for (var i = 0 ; i < 4 ; i++) {
				var x2 = x + dx[i];
				var y2 = y + dy[i];
				var allriver = true;
				for (var dx2 = 0 ; dx2 <= 1 ; dx2++) {
					for (var dy2 = 0 ; dy2 <= 1 ; dy2++) {
						if (dx[i] + dx2 == 0 && dy[i] + dy2 == 0) {
							continue;
						}
						var x3 = x2 + dx2;
						var y3 = y2 + dy2;
						if (!this.isinside(x3, y3) || map[x3][y3] != "river") {
							allriver = false;
						}
					}
				}
				if (allriver == true) {
					return false;
				}
			}
			return true;
		}

		this.deletenearreef = function(x, y) {
			var map = this.savedata.mapdata.map;
			if (this.isinside(x, y)) {
				for (var dx = -1 ; dx <= 1 ; dx++) {
					for (var dy = -1 ; dy <= 1 ; dy++) {
						if (dx == 0 && dy == 0) {
							continue;
						}
						var x2 = x + dx;
						var y2 = y + dy;
						if (this.isinside(x2, y2) && map[x2][y2] == "reef") {
							map[x2][y2] = "sea";
						}
					}
				}
			}
		}

		this.changemap = function(x, y, tname) {
			var map = this.savedata.mapdata.map;
			if (this.isinside(x, y)) {
				var t = Terrain_imglist[map[x][y]];
				if (t.large == true) {
					for (var dx = 0 ; dx < t.size ; dx++) {
						for (var dy = 0 ; dy < t.size ; dy++) {
							var x2 = x - t.imgdata.x + dx;
							var y2 = y - t.imgdata.y + dy;
							map[x2][y2] = "plain";
							this.deletenearreef(x2, y2);
						}
					}
				}
				map[x][y] = tname;
				t = Terrain_imglist[tname];
				if (t.land == true) {
					this.deletenearreef(x, y);
				}
			}
		}

		this.setmap = function(x, y, tname, check) {
			var map = this.savedata.mapdata.map;
			check = check || false;
			retval = false;
			var t = Terrain_imglist[tname];
			if (this.isinside(x, y)) {
				if (tname == "pipe_c") {
					if (map[x][y] == "pipe" && 
						((this.isinside(x - 1, y) && map[x - 1][y] == "pipe" && this.isinside(x + 1, y) && map[x + 1][y] == "pipe") ||
						 (this.isinside(x, y - 1) && map[x][y - 1] == "pipe" && this.isinside(x, y + 1) && map[x][y + 1] == "pipe"))) {
							retval = true;
							if (!check) {
								this.changemap(x, y, tname);
							}
					}
				}
				else if (tname == "reef") {
					if (map[x][y] == "sea") {
						retval = true;
						if (!check) {
							this.changemap(x, y, tname);
							for (var dx = -1 ; dx <= 1 ; dx++) {
								for (var dy = -1 ; dy <= 1 ; dy++) {
									if (dx == 0 && dy == 0) {
										continue;
									}
									var x2 = x + dx;
									var y2 = y + dy;
									if (this.isinside(x2, y2) && Terrain_imglist[map[x2][y2]].sea != true) {
										this.changemap(x2, y2, "sea");
									}
								}
							}
						}
					}
				}
				else if (tname == "shoal") {
					if (map[x][y] == "sea") {
						retval = true;
						if (!check) {
							this.changemap(x, y, tname);
						}
					}
				}
				else if (tname == "river" || tname == "wideriver") {
					//if (Terrain[map[x][y]].land == true || Terrain[map[x][y]].pipe == true) {
						if (tname == "wideriver" || this.cansetriver(x, y)) {
							retval = true;
							if (!check) {
								this.changemap(x, y, tname);
							}
						}
					//}
				}
				else if (t.hq == true && t.country != "no") {
					retval = true;
					if (!check) {
						for (var x2 = 0; x2 < this.width ; x2++) {
							for (var y2 = 0 ; y2 < this.height ; y2++) {
								var t2 = Terrain[Terrain_indextable[map[x2][y2]]];
								if (t2.hq == true && t.country == t2.country) {
									this.changemap(x2, y2, Terrain_indextable["plain"]);
								}
							}
						}
						this.changemap(x, y, tname);
					}
				}
				else if (t.large) {
					if (x + t.size - 1 < this.savedata.mapdata.width && y + t.size - 1 < this.savedata.mapdata.height) {
						retval = true;
						if (!check) {
							for (var dy = 0 ; dy < t.size ; dy++) {
								for (var dx = 0 ; dx < t.size ; dx++) {
									this.changemap(x + dx, y + dy, tname + dx + "" + dy);
								}
							}
						}
					}
				}
				else {
					retval = true;
					if (!check) {
						this.changemap(x, y, tname);
					}
				}
			}
			return retval;
		}

		this.setcanvas = function() {
			this.canvas.width = Sqsize * this.savedata.mapdata.width;
			this.canvas.height = Sqsize * this.savedata.mapdata.height + 16;
			if (this.usetool) {
				this.canvas.width += Toolwidth;
				if (this.canvas.height < Toolheight) {
					this.canvas.height = Toolheight;
				}
			}

			this.tx = Sqsize * this.savedata.mapdata.width;
			this.ty = 0;
		}

		this.init = function(w, h, clear) {
			this.setsize(w, h, clear);
			this.setcanvas();
		}

		this.savedata.mapdata = {
			width:		Defaultwidth,
			height:		Defaultheight,
			maptype:	0,
			map:			[],
		};

		this.savedata.countrydata = {};
		for (var i = 0 ; i < Country.length ; i++) {
			var c = Country[i];
			if (c.npc) {
				continue;
			}
			this.savedata.countrydata[c.fname] = {
				front: {
					shogun:	null,
					bp:			0
				},
				back:	{
					shogun: null,
					bp:			0
				},
				money: 0,
				unitdirection:	"right",
				unitdata: [],
			}
		}

		this.ButtonUI = new UI({ x: 0, y: 0, imgpath: "image/button/", imgext: ".png", defaultwidth: Tool_button_width, defaultheight: Tool_button_height }, ButtonUI_data);

		this.ModeUI = new UI({ type: "selector", x: 0, y: Tool_button_height, select: { fillStyle: "white" }, defaultwidth: Tool_mode_width, defaultheight: Tool_mode_height }, ModeUI_data);

		this.TerrainUI = new UI({ type: "selector", x: 0, y: Tool_button_height + Tool_mode_height, select: { fillStyle: Tool_select_rectcolor }, unselect: { fillStyle: "transparent" }, px: 16, py: 16, space: 6, defaultwidth: 24, defaultheight: 24, lineheight: 30, imgpx: 4, imgpy: 4 }, TerrainUI_data);

		this.ExtraUI = new UI({ type: "selector", x: 0, y: Tool_button_height + Tool_mode_height, select: { fillStyle: Tool_select_rectcolor }, unselect: { fillStyle: "transparent" }, px: 16, py: 16, space: 6, defaultwidth: 24, defaultheight: 24, lineheight: 30, imgpx: 4, imgpy: 4 }, ExtraUI_data);

		this.UnitCountryUI = new UI({ type: "selector", x: 0, y: Tool_button_height + Tool_mode_height, imgpath: "image/button/", imgext: ".png", select: { fillStyle: Tool_select_rectcolor }, unselect: { fillStyle: "transparent" }, px: 16, py: 16, space: 6, defaultwidth: 24, defaultheight: 24, lineheight: 30, imgpx: 4, imgpy: 4 }, UnitCountryUI_data);

		this.MapsizeUI = new UI({ x: 0, y: Tool_button_height + Tool_mode_height + Toolpy }, MapsizeUI_data);

		this.init(this.savedata.mapdata.width, this.savedata.mapdata.height, true);
		this.draw();
	}
	return FWEditor;
}());
